//==============================================================================
// Product name: ExprEvalExampleMain
// Copyright 2007 Alexei Cioina (cioina.com).
// Version: 1.1.8
// Date: 12/07/2007
// Comment:  This version does not support Kylix
//==============================================================================
unit ExprEvalExampleMain;
{$DEFINE TCompEv}

//{$DEFINE RemObjectPS}
//{$DEFINE PaxScrip}
//{$DEFINE PaxComp}
//{$DEFINE ScriptStudio}
//{$DEFINE ExprParser3}
//{$DEFINE FastScript}
//{$DEFINE DelphiWebScript2}
//{$DEFINE EquTranslator2}
//{$DEFINE Ucalc2}

interface

uses
  Windows, SysUtils, Classes, Graphics, Controls, Forms, StdCtrls,Dialogs,
  ExtCtrls, jpeg, ComCtrls,  
  CioinaEval, 
  JclExprEval,
  prExpr, 
  StExpr, 
  Parser10, 
  CalcExpress,
  ParseExpr, 
  PegtopFormulas, 
  SsExpEval, 
  RbwParser, 
  Symbolic, 
  MathParser,
  DiffExpress,
  formula, 
  formulan,
  
  {$IFDEF RemObjectPS}uPSCompiler, uPSRuntime, uPSUtils,{$ENDIF}
  {$IFDEF PaxScrip}PaxScripter, paxPascal,{$ENDIF}
  {$IFDEF PaxComp}PaxCompiler, PaxProgram,{$ENDIF}
  {$IFDEF ScriptStudio}atScript, atPascal,{$ENDIF}
  {$IFDEF ExprParser3}ExPars, Vars, ExLink, ParsType, ExEval, ExFuncs, ExClass, epBDEReg,{$ENDIF}
  {$IFDEF FastScript}fs_iinterpreter, fs_ipascal,{$ENDIF}
  {$IFDEF DelphiWebScript2}dws2Comp, dws2Exprs,{$ENDIF}
  {$IFDEF EquTranslator2}EquTranslator,{$ENDIF}
  {$IFDEF Ucalc2}UCalc,{$ENDIF}

  // ExpressIt
  ResultSupport, ExpressIt, Expression, ExpressionParser, ExpressionStack, 
  ExpressionLexicon, ExpressionObjects, TokenSupport;

type
// RemObjects Pascal Scripter
{$IFDEF RemObjectPS}
  TTestFunction = function (const x, y, z :Double): string of object;
{$ENDIF}

// PaxCompiler
{$IFDEF PaxComp}
  TProcP = procedure (x, y, z :Double); stdcall;
{$ENDIF}


  TForm1 = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    GroupBox1: TGroupBox;
    Splitter1: TSplitter;
    Memo1: TMemo;
    Memo2: TMemo;
    Panel1: TPanel;
    Label2: TLabel;
    Label1: TLabel;
    Edit1: TEdit;
    EnterButton: TButton;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    CheckBox6: TCheckBox;
    CheckBox7: TCheckBox;
    CheckBox8: TCheckBox;
    CheckBox9: TCheckBox;
    CheckBox10: TCheckBox;
    CheckBox11: TCheckBox;
    CheckBox12: TCheckBox;
    CheckBox13: TCheckBox;
    CheckBox14: TCheckBox;
    CheckBox15: TCheckBox;
    CheckBox16: TCheckBox;
    CheckBox17: TCheckBox;
    CheckBox18: TCheckBox;
    CheckBox19: TCheckBox;
    TabSheet2: TTabSheet;
    PaintBox1: TPaintBox;
    Panel2: TPanel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Button1: TButton;
    RadioGroup1: TRadioGroup;
    Edit5: TEdit;
    cbDraw: TCheckBox;
    Label7: TLabel;
    Edit6: TEdit;
    Label8: TLabel;
    TabSheet3: TTabSheet;
    GroupBox2: TGroupBox;
    DiffVar: TEdit;
    Button2: TButton;
    GroupBox3: TGroupBox;
    Memo3: TMemo;
    Splitter2: TSplitter;
    GroupBox4: TGroupBox;
    Memo4: TMemo;
    GroupBox5: TGroupBox;
    Splitter3: TSplitter;
    Memo5: TMemo;
    CheckBox20: TCheckBox;
    CheckBox21: TCheckBox;
    CheckBox22: TCheckBox;
    CheckBox23: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure EnterButtonClick(Sender: TObject);
    procedure cbDrawClick(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }

   // RemObjects Pascal Scripter
   {$IFDEF RemObjectPS}
    Compiler          : TPSPascalCompiler;
      { TPSPascalCompiler is the compiler part of the scriptengine. This will
        translate a Pascal script into a compiled for the executer understands. }
    Exec              : TPSExec;
     { TPSExec is the executer part of the scriptengine. It uses the output of
       the compiler to run a script. }
    ByteCodeData      : string;
    TestFunc          : TTestFunction;
    xPS,yPS,zPS       : Double; 
   {$ENDIF}
   
   // PaxScripter
   {$IFDEF PaxScrip}
    p                : TPaxScripter;
    lang             : tPaxLanguage;
   {$ENDIF}

   // PaxCompiler
   {$IFDEF PaxComp}
    PaxCompiler1			: TPaxCompiler;
    PaxPascalLanguage1: TPaxPascalLanguage;
    PaxProgram1				: TPaxProgram;
    H_Res, 
    H_Proc						: Integer;
    ProcPointer				: Pointer;
    R                 : Double;
   {$ENDIF}

   // ScripterStudio
   {$IFDEF ScriptStudio}
    FScripter         : TatPascalScripter;
    StudX,StudY,StudZ : Double;  
    ARoutine          : string;    
  {$ENDIF}
  
  // Sparksoft 's Expression Parser 
  {$IFDEF ExprParser3}
    SparkParser1      : TExParser;
    SpX, SpY, SpZ     : TVariable;
  {$ENDIF}

  // Fast Script
  {$IFDEF FastScript} 
    fsScript1         : TfsScript;
    fsX, fsY, fsZ     : Double;
    Params            : Variant;
  {$ENDIF}

  // DelphiWebScript II
  {$IFDEF DelphiWebScript2}
    Script            : TDelphiWebScriptII;
    prog              : TProgram; 
  {$ENDIF}
   
     // JclExprEval
     {$IFDEF TCompEv}
      FEvaluator      : TCompiledEvaluator;
      FConstEvaluator : JclExprEval.TEvaluator;
     {$ELSE}
      FEvaluator      : JclExprEval.TEvaluator;
     {$ENDIF}
      x,y,z           : Double;

     // EquTranslator
     {$IFDEF EquTranslator2}
      EquTranslatorArgs            : array[0..2] of double;
      EquTranslatorMathFunc        : PChar;
     {$ENDIF}

     // UCalc
     {$IFDEF Ucalc2}
      UserEq, VariableX, VariableY, VariableZ: Longint;
     {$ENDIF}

     // CioinaEval
     Ev               : TCioinaEval;
     P1,P2,P3         : PTReal;
     ar               : TUserVarArray;
     CioinaEvalError  : string;

     // StExpr
     Expr             : TStExpression;
     xx,yy,zz         : Extended;

     // Parser10
     DynaParser       : TParser;
     PP               : Parser10.PParserFloat;

     // RbwParser
     RbwParser1       : TRbwParser;
     VarX,VarY,VarZ   : TRealVariable;
     PiFunction,
     SumFunction      : TFunctionRecord;

     // ExpressionParser
     ExprParser1      : TExpressionParser;

     // SadMan's ExpressionEvaluator
     ExpressionEvaluator1: TExpressionEvaluator;

     // PegtopFormula
     Formula          : TPegtopFormula;
     
     // UnitParsor
     //VarEval          : TExpress;
     
     // ExpressIt
     ExpressIt1       : TExpressIt;
     vExpression1     : TExpression; 

     // CalcExpess2
     CalcExpress1     : TCalcExpress;
     VarList          : TMemo;
     args             : array [0..2] of extended; 
     
     // DiffExpress
     DiffExpress1     : TDiffExpress;

     // Symbolic
     Expr1            : Symbolic.TExpression;
     Eval             : Symbolic.TEvaluator;
     VarName          : TStringList;
     Vars             : array[0..2] of ArbFloat;

     //  MathParser
     AFuncParser      : TMathParser;
     AFuncTree        : PTTermTreeNode;

     //  ArtFormula
     FN               : TArtFormulaN;
     vals             : DoubleArray;
     varArr           : StringArray;

     // prExpr
     EG3Expr          : IValue;
     function EG2IDFunc( const Identifier: String;
                           ParameterList: TParameterList): IValue;
     procedure Evaluate;
     
     // PaxScripter
    {$IFDEF PaxScrip}
     procedure doOnError(Sender: TPaxScripter);
    {$ENDIF}
     
     // ScripterStudio
    {$IFDEF ScriptStudio}
      procedure SSTan(AMachine: TatVirtualMachine);
      procedure MySin(AMachine: TatVirtualMachine);
      procedure GetX(AMachine: TatVirtualMachine);
      procedure GetY(AMachine: TatVirtualMachine);
      procedure GetZ(AMachine: TatVirtualMachine);
    {$ENDIF}
    
    // CioinaEval
    procedure ExecuteErrorMesssage(Sender: TObject);
    procedure ParseErrorMesssage(Sender: TObject);
  public
    { Public declarations }
    
     // ExpressIt
     xIt,yIt,zIt      : Double;
    
  end;


  // ExpressIt
  TXValue = class(TExpressionFunction)
  public
    class function Symbol: string; override;
    class function Syntax: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TYValue = class(TExpressionFunction)
  public
    class function Symbol: string; override;
    class function Syntax: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TZValue = class(TExpressionFunction)
  public
    class function Symbol: string; override;
    class function Syntax: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;
  TAbs = class(TExpressionFunctionWith1Arg)
  public
    class function Symbol: string; override;
    class function Syntax: string; override;
    procedure Execute(Sender: TObject; AStack: TExpressionStack); override;
  end;

  
var
  Form1: TForm1;
  CompiledTime  : Double;

implementation


{$R *.DFM}


uses JclMath, Math, Variants;

// PaxScripter
{$IFDEF PaxScrip}
procedure TForm1.doOnError(Sender: TPaxScripter);
begin
end;
{$ENDIF}

// UCalc
{$IFDEF Ucalc2}
function ucalcAverage: Extended;
var
  x: Longint;
  Total: Extended;
begin
  Total := 0;
  for x := 1 to ucParamCount do Total := Total + ucParam[x];
  ucalcAverage := Total / ucParamCount;
end;
{$ENDIF}
 
// RemObjects Pascal Scripter
{$IFDEF RemObjectPS}
function ScriptOnExportCheck(Sender: TPSPascalCompiler; Proc: TPSInternalProcedure; const ProcDecl: string): Boolean;
{
  The OnExportCheck callback function is called for each function in the script
  (Also for the main proc, with '!MAIN' as a Proc^.Name). ProcDecl contains the
  result type and parameter types of a function using this format:
  ProcDecl: ResultType + ' ' + Parameter1 + ' ' + Parameter2 + ' '+Parameter3 + .....
  Parameter: ParameterType+TypeName
  ParameterType is @ for a normal parameter and ! for a var parameter.
  A result type of 0 means no result.
}
begin
  if Proc.Name = 'TEST' then // Check if the proc is the Test proc we want.
  begin
    if not ExportCheck(Sender, Proc, [btString, btDouble, btDouble, btDouble], [pmIn, pmIn, pmIn]) then // Check if the proc has the correct params.
    begin
      { Something is wrong, so cause an error. }
      Sender.MakeError('', ecTypeMismatch, '');
      Result := False;
      Exit;
    end;
    Result := True;
  end else Result := True;
end;

function ScriptOnUses(Sender: TPSPascalCompiler; const Name: string): Boolean;
{ the OnUses callback function is called for each "uses" in the script.
  It's always called with the parameter 'SYSTEM' at the top of the script.
  For example: uses ii1, ii2;
  This will call this function 3 times. First with 'SYSTEM' then 'II1' and then 'II2'.
}
begin
  if Name = 'SYSTEM' then
  begin
    Sender.AddDelphiFunction('function MySum(x, y, z: Double):Double');
    Sender.AddDelphiFunction('function Tan(x: Double):Double');
    { This will register the function to the script engine. Now it can be used from within the script. }
    Result := True;
  end else
    Result := False;
end;

function PSTAN(const x:Double):Double;
begin
  Result:= Tan(x);
end;
function PSSUM(const x, y, z :Double):Double;
begin
  Result:= x + y + z;
end;
{$ENDIF}

   // ScripterStudio
{$IFDEF ScriptStudio}
procedure TForm1.SSTan(AMachine: TatVirtualMachine);
begin
    AMachine.ReturnOutputArg(Tan(AMachine.GetInputArgAsFloat(0)));
end;
procedure TForm1.MySin(AMachine: TatVirtualMachine);
begin
    AMachine.ReturnOutputArg(Sin(AMachine.GetInputArgAsFloat(0)));
end;
procedure TForm1.GetX(AMachine: TatVirtualMachine);
begin
    AMachine.ReturnOutputArg(StudX);
end;
procedure TForm1.GetY(AMachine: TatVirtualMachine);
begin
    AMachine.ReturnOutputArg(StudY);
end;
procedure TForm1.GetZ(AMachine: TatVirtualMachine);
begin
    AMachine.ReturnOutputArg(StudZ);
end;
{$ENDIF}

  // Sparksoft 's Expression Parser 
{$IFDEF ExprParser3}
  procedure SparkRand(AnOper: PParserOperation);
  begin
   AnOper^.dest^:= Random;
  end;
  procedure SparkSum(AnOper: PParserOperation);
  var i:Integer;
  begin
    with AnOper^ do begin
    for i:=1 to ArgCnt do
      case I of
        1: dest^:=arg1^;
        2: dest^:=dest^+arg2^;
        3: dest^:=dest^+arg3^;
       else dest^:=dest^+args^[I-1]^;
      end;
    end;
  end;
{$ENDIF}

// JclExprEval
function MyTan(x:Double):Double;
begin
   Result:= Tan(x);
end;
function MyAbs(x:Double):Double;
begin
   Result:= Abs(x);
end;
function MyLn(x:Double):Double;
begin
   Result:= LogN(Exp(1),x);
end;
function MyPower(x,y:Double):Double;
begin
   Result:=Power(x,y);
end;
function MySum(x,y,z:Double):Double;
begin
   Result:=x+y+z;
end;
function MyRandom:Double;
begin
   Result:=Random;
end;
//----------------------------------------------------------------------------
// StExpr
function RandomEx:Extended;
begin
   Result:=Random;
end;
function MySumEx(x,y,z:Extended):Extended;
begin
   Result:=x+y+z;
end;
function MyPowerEx(x,y:Extended):Extended;
begin
   Result:=Math.Power(x,y);
end;
//----------------------------------------------------------------------------
// Parser10
procedure MyFuncPr(AnOperation: POperation);
begin
 with  AnOperation^ do
 begin
  Dest^:=2*Arg1^;
 end;
end;
procedure MyPowerPr(AnOperation: POperation);
begin
 with  AnOperation^ do
 begin
  Dest^:=Power(Arg1^, Arg2^);
 end;
end;
//----------------------------------------------------------------------------
// RbwParser 
function _HalfPi(Values : array of pointer) : double;
begin
  result := Pi/2;
end;
function _Sum(Values : array of pointer) : double;
begin
  result := PDouble(Values[0])^ + PDouble(Values[1])^ + PDouble(Values[2])^;
end;
//----------------------------------------------------------------------------
//CioinaEval
function CioinaRandom(Sender: TObject; FuncRef: PVectorFuncRef;Pv:PVectorPTReal;PvCount:Integer):TReal;
begin
   Result:=Random;
end;
function CioinaMySum(Sender: TObject; FuncRef: PVectorFuncRef;Pv:PVectorPTReal;PvCount:Integer):TReal;
var i:Integer;
begin
  Result:=0;
  for i:=1 to  PvCount do  Result:=Result + Pv[i]^;
end;

procedure TForm1.ExecuteErrorMesssage(Sender: TObject);
var s,s1:string;
    i   :Integer;
begin
 with Sender as TCioinaEval do
 begin
  CioinaEvalError:='';
  i:=Pos(':',ErrorMessageInfo);
  if i>0 then  s1:=' : '+Copy(ErrorMessageInfo,i+1,Length(ErrorMessageInfo)-i) else s1:='';
  if Length(s1)>256 then s1:=Copy(s1,1,256);
  s1:=LowerCase(s1);

  s:='';
  case MathException of
   EX_NONMATH:s:=' : NONMATH';
   EX_Overflow:s:=' : Overflow';
   EX_Underflow:s:=' : Underflow';
   EX_InvalidArgument:s:=' : InvalidArgument';
   EX_ZeroDivide:s:=' : ZeroDivide';
   EX_InvalidOp:s:=' : InvalidOp';
  end;

  case ErrorNumber of
   ERR_NO_MATH_EXPRESSION_WAS_PARSED:           CioinaEvalError:=('No math expression was parsed');
   ERR_VARIABLES_AND_VALUES_ARE_DIFFERENT:      CioinaEvalError:=('Variable count and value caunt do not corespond');
   ERR_MATH_EXPRESSIONS_ARRAY:                  CioinaEvalError:=('Use ''DoVectorOfMathExpressions'' for calculate a vector of math expression');
   ERR_DEF_FUNCTION_STACK_OVERFLOW:             CioinaEvalError:=('Stack overflow'+s1);
   ERR_SYSTEM_STACK_OVERFLOW:                   CioinaEvalError:=('Fatal error'+s1);
   ERR_EXECUTE:                                 CioinaEvalError:=('Execution error'+s1);
   ERR_MULTIPLY:                                CioinaEvalError:=('Invalid value for *'+s1+s);
   ERR_DIVISION:                                if MathException=EX_ZeroDivide
                                                then CioinaEvalError:=('Division by 0 ')
                                                else CioinaEvalError:=('Invalid value for /'+s1+s);
   ERR_PLUS:                                    CioinaEvalError:=('Invalid value for +'+s1+s);
   ERR_MINUS:                                   CioinaEvalError:=('Invalid value for -'+s1+s);
   ERR_POWER:                                   CioinaEvalError:=('Invalid value for ^'+s1+s);
   ERR_EQUAL:                                   CioinaEvalError:=('Invalid value for ='+s1+s);
   1..FunCount:
               if s=''
               then CioinaEvalError:=('Invalid number of function arguments for: '+ UpperCase(aStr[ErrorNumber]))
               else CioinaEvalError:=('Invalid value for '+ UpperCase(aStr[ErrorNumber])+s1+s);
   else if (ErrorNumber>FunCount)and(ErrorNumber<=FunCount+UserFunctionCount)
        then
         if s=''
         then  CioinaEvalError:=('Invalid number of function arguments for: '+UpperCase(UserFunctionName[ErrorNumber-FunCount-1]))
         else  CioinaEvalError:=('Invalid value for '+ UpperCase(UserFunctionName[ErrorNumber-FunCount-1])+s1+s)
        else CioinaEvalError:=(ErrorMessageInfo);
  end;
 end;
end;
//---------------------------------------------------------------------------
procedure TForm1.ParseErrorMesssage(Sender: TObject);
var s,s1:string;
    i :Integer;
begin
 with Sender as TCioinaEval do
 begin
  CioinaEvalError:='';
  i:=Pos(':',ErrorMessageInfo);
  if i>0 then  s1:=' : '+Copy(ErrorMessageInfo,i+1,Length(ErrorMessageInfo)-i) else s1:='';
  if Length(s1)>256 then s1:=Copy(s1,1,256);
  s1:=LowerCase(s1);
  s:='';
  case MathException of
   EX_NONMATH:s:=' : NONMATH';
   EX_Overflow:s:=' : Overflow';
   EX_Underflow:s:=' : Underflow';
   EX_InvalidArgument:s:=' : InvalidArgument';
   EX_ZeroDivide:s:=' : ZeroDivide';
   EX_InvalidOp:s:=' : InvalidOp';
  end;

  case ErrorNumber of
   ERR_PARSE:                                   CioinaEvalError:=('Invalid expression'+s1);
   ERR_BAD_SYNTAX:                              CioinaEvalError:=('Syntax error'+s1);
   ERR_COMMA_SYNTAX:                            CioinaEvalError:=('Comma syntax error'+s1);
   ERR_NO_MATH_EXPRESSION_WAS_PARSED:           CioinaEvalError:=('No math expression was parsed');
   ERR_PARANTHESES_SYNTAX_ERROR:                CioinaEvalError:=('Mismatched parenthesis');
   ERR_INVALID_DERIVATIVE_VARIABLE_NAME:        CioinaEvalError:=('Invalid name of derivative variable'+s1);
   ERR_MATH_EXPRESSION_IS_EMPTY:                CioinaEvalError:=('Mathematical expression is empty');
   ERR_IDENTIFIER_CANNOT_BE_EMPTY:              CioinaEvalError:=('Identifier cannot be empty');
   ERR_IDENTIFIER_LENGTH:                       CioinaEvalError:=('Identifier length is too long'+s1);
   ERR_NOT_PASCAL_IDENTIFIER:                   CioinaEvalError:=('Invalid identifier'+s1);
   ERR_IDENTIFIER_CANNOT_BE_RESERVED_NAME:      CioinaEvalError:=('Identifier cannot be a reserved name'+s1);
   ERR_IDENTIFIER_ALREADY_EXISTS:               CioinaEvalError:=('Identifier already exists'+s1);
   ERR_DUBLICATING_USER_IDENTIFIER:             CioinaEvalError:=('Dublicating user identifier'+s1);
   ERR_UNKNOWN_EXPRESSION:                      CioinaEvalError:=('Unknown expression'+s1);
   ERR_UNKNOWN_FUNCTION:                        CioinaEvalError:=('Undefined function'+s1);
   ERR_UNKNOWN_VARIABLE:                        CioinaEvalError:=('Undefined variable'+s1);
   ERR_BAD_EXPONENTIAL_FORMAT:                  CioinaEvalError:=('Invalid exponent value'+s1);
   ERR_SET_OriginalMathExpressionString_FALSE:  CioinaEvalError:=('Set ''OriginalMathExpressionString'' to FALSE for differentiation or for Mathematica 4.1 export');
   ERR_MATH_EXPRESSION_WAS_ERASED:              CioinaEvalError:=('Mathematical expression string was erased');
   ERR_USE_VerifySyntaxSemanticsAndDerivation:  CioinaEvalError:=('Use ''VerifySyntaxSemanticsAndDerivation'' for differentiation');
   ERR_DERIVATIVE_EXPRESSION_WAS_ERASED:        CioinaEvalError:=('Derivative expression string was erased');
   ERR_VARIABLES_AND_VALUES_ARE_DIFFERENT:      CioinaEvalError:=('Variable count and value caunt do not corespond');
   ERR_MATH_EXPRESSIONS_ARRAY:                  CioinaEvalError:=('Use ''DoVectorOfMathExpressions'' for calculate a vector of math expression');
   ERR_FUNCTION_NUMBER_MUST_BE_LESS:            CioinaEvalError:=('Function number must be less'+s1);
   ERR_FUNCTION_ADDRESS_CANNOT_BE_NIL:          CioinaEvalError:=('Function address cannot be nil'+s1);
   ERR_PROTECTED_EXPRESSION:                    CioinaEvalError:=('Cannot set value for protected expression'+s1);
   ERR_DEF_FUNC_NAME:                           CioinaEvalError:=('Invalid function name'+s1);
   ERR_DEF_FUNC_DUBLICATING:                    CioinaEvalError:=('Dublicating defined function'+s1);
   ERR_DEF_FUNC_IMPLEMENTING:                   CioinaEvalError:=('Defined function was not implimented'+s1);
   ERR_DEF_FUNC_ARG_COUNT:                      CioinaEvalError:=('Invalid arguments number for defined function'+s1);
   ERR_DEF_FUNC_ARG_NAME:                       CioinaEvalError:=('Invalid argument name for defined function'+s1);
   ERR_DEF_FUNC_ARG_DUBLICATING:                CioinaEvalError:=('Dublicating argument name for defined function'+s1);
   ERR_MULTIPLY:                                CioinaEvalError:=('Invalid value for *'+s1+s);
   ERR_DIVISION:                                if MathException=EX_ZeroDivide
                                                then CioinaEvalError:=('Division by 0')
                                                else CioinaEvalError:=('Invalid value for /'+s1+s);
   ERR_PLUS:                                    CioinaEvalError:=('Invalid value for +'+s1+s);
   ERR_MINUS:                                   CioinaEvalError:=('Invalid value for -'+s1+s);
   ERR_POWER:                                   CioinaEvalError:=('Invalid value for ^'+s1+s);
   ERR_EQUAL:                                   CioinaEvalError:=('Invalid value for ='+s1+s);
   1..FunCount:
               if s=''
               then CioinaEvalError:=('Invalid number of function arguments for: '+ UpperCase(aStr[ErrorNumber]))
               else CioinaEvalError:=('Invalid value for '+ UpperCase(aStr[ErrorNumber])+s1+s);
   else if (ErrorNumber>FunCount)and(ErrorNumber<=FunCount+UserFunctionCount)
        then
         if s=''
         then  CioinaEvalError:=('Invalid number of function arguments for: '+UpperCase(UserFunctionName[ErrorNumber-FunCount-1]))
         else  CioinaEvalError:=('Invalid value for '+ UpperCase(UserFunctionName[ErrorNumber-FunCount-1])+s1+s)
        else CioinaEvalError:=(ErrorMessageInfo);
  end;
 end;
end;

//----------------------------------------------------------------------------
// ExpressIt
class function TXValue.Symbol: string;
begin
  Result := 'x';
end;
class function TXValue.Syntax: string;
begin
  Result := 'double = x';
end;
procedure TXValue.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  AStack.Push(Form1.xIt);
end;

class function TYValue.Symbol: string;
begin
  Result := 'y';
end;
class function TYValue.Syntax: string;
begin
  Result := 'double = y';
end;
procedure TYValue.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  AStack.Push(Form1.yIt);
end;

class function TZValue.Symbol: string;
begin
  Result := 'z';
end;
class function TZValue.Syntax: string;
begin
  Result := 'double = z';
end;
procedure TZValue.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  AStack.Push(Form1.zIt);
end;

class function TAbs.Symbol: string;
begin
  Result := 'abs';
end;
class function TAbs.Syntax: string;
begin
  Result := 'double = abs(double)';
end;
procedure TAbs.Execute(Sender: TObject; AStack: TExpressionStack);
begin
  AStack.Push(Abs(AStack.Pop));
end;

//----------------------------------------------------------------------------
// prExpr
type
  TEnum = (enValA, enValB, enValC, enValE, enValF);
var
  xxx,yyy,zzz:Double;

type
  ClsX = class(prExpr.TFunction)
  protected
    function TestParameters: Boolean; override;
  public
    function AsFloat: Double; override;
    function ExprType: TExprType; override;
  end;

function ClsX.TestParameters: Boolean;
begin
  Result:= (ParameterCount = 0);
end;
function ClsX.AsFloat: Double;
begin
  Result:= xxx;
end;
function ClsX.ExprType: TExprType;
begin
  Result:= ttFloat
end;

type
  ClsY = class(prExpr.TFunction)
  protected
    function TestParameters: Boolean; override;
  public
    function AsFloat: Double; override;
    function ExprType: TExprType; override;
  end;

function ClsY.TestParameters: Boolean;
begin
  Result:= (ParameterCount = 0);
end;
function ClsY.AsFloat: Double;
begin
  Result:= yyy;
end;
function ClsY.ExprType: TExprType;
begin
  Result:= ttFloat
end;

type
  ClsZ = class(prExpr.TFunction)
  protected
    function TestParameters: Boolean; override;
  public
    function AsFloat: Double; override;
    function ExprType: TExprType; override;
  end;

function ClsZ.TestParameters: Boolean;
begin
  Result:= (ParameterCount = 0);
end;
function ClsZ.AsFloat: Double;
begin
  Result:= zzz;
end;
function ClsZ.ExprType: TExprType;
begin
  Result:= ttFloat
end;

type
  ClsRand = class(prExpr.TFunction)
  protected
    function TestParameters: Boolean; override;
  public
    function AsFloat: Double; override;
    function ExprType: TExprType; override;
  end;

function ClsRand.TestParameters: Boolean;
begin
  Result:= (ParameterCount = 0);
end;
function ClsRand.AsFloat: Double;
begin
  Result:= Random;
end;
function ClsRand.ExprType: TExprType;
begin
  Result:= ttFloat
end;

type
  ClsPower = class(prExpr.TFunction)
  protected
    function TestParameters: Boolean; override;
  public
    function AsFloat: Double; override;
    function ExprType: TExprType; override;
  end;

function ClsPower.TestParameters: Boolean;
var i:Integer;
begin
  Result:= (ParameterCount=2);
  if Result
  then for i:=0 to ParameterCount-1 do
       begin
        Result:=Param[i].CanReadAs(ttFloat);
        if not(Result) then Break;
       end;

end;
function ClsPower.AsFloat: Double;
var i:Integer;
begin
   Result:=Power(Param[0].AsFloat,Param[1].AsFloat);
end;
function ClsPower.ExprType: TExprType;
begin
  Result:= ttFloat
end;

type
  ClsTan = class(prExpr.TFunction)
  protected
    function TestParameters: Boolean; override;
  public
    function AsFloat: Double; override;
    function ExprType: TExprType; override;
  end;

function ClsTan.TestParameters: Boolean;
var i:Integer;
begin
  Result:= (ParameterCount=1);
  if Result
  then for i:=0 to ParameterCount-1 do
       begin
        Result:=Param[i].CanReadAs(ttFloat);
        if not(Result) then Break;
       end;

end;
function ClsTan.AsFloat: Double;
var i:Integer;
begin
   Result:=Tan(Param[0].AsFloat);
end;
function ClsTan.ExprType: TExprType;
begin
  Result:= ttFloat
end;

type
  ClsSum = class(prExpr.TFunction)
  protected
    function TestParameters: Boolean; override;
  public
    function AsFloat: Double; override;
    function ExprType: TExprType; override;
  end;

function ClsSum.TestParameters: Boolean;
var i:Integer;
begin
  Result:= (ParameterCount>=1)and(ParameterCount <=MaxInt);
  if Result
  then for i:=0 to ParameterCount-1 do
       begin
        Result:=Param[i].CanReadAs(ttFloat);
        if not(Result) then Break;
       end;

end;
function ClsSum.AsFloat: Double;
var i:Integer;
begin
  Result:=0;
  for i:=0 to ParameterCount-1 do
   Result:=Result+Param[i].AsFloat;
end;
function Clssum.ExprType: TExprType;
begin
  Result:= ttFloat
end;


function TForm1.EG2IDFunc( const Identifier: String;
                              ParameterList: TParameterList): IValue;
begin
  if Identifier = 'TAN' then
  begin
    Result:= ClsTan.Create(ParameterList)
  end else
  if Identifier = 'POWER' then
  begin
    Result:= ClsPower.Create(ParameterList)
  end else
  if Identifier = 'MYSUM' then
  begin
    Result:= ClsSum.Create(ParameterList)
  end else
  if Identifier = 'X' then
  begin
    if Assigned(ParameterList) then
    raise EExpression.CreateFmt('Identifier %s does not require parameters', [Identifier])else
    Result:= ClsX.Create(ParameterList)
  end else
  if Identifier = 'Y' then
  begin
    if Assigned(ParameterList) then
    raise EExpression.CreateFmt('Identifier %s does not require parameters', [Identifier])else
    Result:= ClsY.Create(ParameterList)
  end else
  if Identifier = 'Z' then
  begin
    if Assigned(ParameterList) then
    raise EExpression.CreateFmt('Identifier %s does not require parameters', [Identifier])else
    Result:= ClsZ.Create(ParameterList)
  end else
  if Identifier = 'RAND' then
  begin
    if Assigned(ParameterList) then
    raise EExpression.CreateFmt('Identifier %s does not require parameters', [Identifier])else
    Result:= ClsRand.Create(ParameterList)
  end else
  begin
    Result:= nil
  end
end;

//----------------------------------------------------------------------------
procedure TForm1.FormCreate(Sender: TObject);
var UserFunc : TUserFuncArray;
begin
  DecimalSeparator:='.';

  // RemObjects Pascal Scripter
 {$IFDEF RemObjectPS}
  Compiler := TPSPascalCompiler.Create; // create an instance of the compiler.
  Compiler.OnUses := ScriptOnUses; // assign the OnUses event.
  Compiler.OnExportCheck := ScriptOnExportCheck; // Assign the onExportCheck event.
  Compiler.AllowNoBegin := True;
  Compiler.AllowNoEnd := True; // AllowNoBegin and AllowNoEnd allows it that begin and end are not required in a script. 
  Exec := TPSExec.Create;  // Create an instance of the executer.
  Exec.RegisterDelphiFunction(@PSTAN, 'TAN', cdRegister);
  Exec.RegisterDelphiFunction(@PSSUM, 'MYSUM', cdRegister);
 {$ENDIF}

  // ScripterStudio
 {$IFDEF ScriptStudio}
  FScripter := TatPascalScripter.Create(Application);
  FScripter.AddConstant('PI', PI);
  FScripter.DefineProp('x', tkFloat, GetX, nil);
  FScripter.DefineProp('y', tkFloat, GetY, nil);
  FScripter.DefineProp('z', tkFloat, GetZ, nil);
  FScripter.DefineMethod('Tan', 1, tkFloat, nil, SSTan);
  FScripter.DefineMethod('MySin', 1, tkFloat, nil, MySin);
 {$ENDIF}
   
  // Sparksoft 's Expression Parser 
 {$IFDEF ExprParser3}
  SparkParser1 := TExParser.Create(Self);
  SparkParser1.RegFuncs := TEPRegFuncs.Create(Self);
  SpX:=SparkParser1.SetVariable('x', 0);
  SpY:=SparkParser1.SetVariable('y', 0);
  SpZ:=SparkParser1.SetVariable('z', 0);
  SparkParser1.RegFuncs.ExpLogarithmFuncs:=true;
  SparkParser1.RegFuncs.TrigonomFuncs:=true;
//   procedure   AddFunction(const AFunctionName: string; const Func: TMathProcedure; AnArgCnt: Integer;
//                            ADescr: string; ACat: TFuncCategory);
  SparkParser1.RegFuncs.AddFunction('MySum', SparkSum, -1 {Unlimited number of arguments},'My SUM function', fct_Arithm);
  SparkParser1.RegFuncs.AddFunction('MyRand', SparkRand, 0 ,'My Random function', fct_Arithm);
 {$ENDIF}

   // Fast Script
  {$IFDEF FastScript} 
    fsScript1:= TfsScript.Create(Self);
    fsScript1.Parent := fsGlobalUnit;
    fsScript1.AddConst('pi', 'Extended', Pi);
    fsScript1.AddVariable('x', 'Double', fsX);
    fsScript1.AddVariable('y', 'Double', fsY);
    fsScript1.AddVariable('z', 'Double', fsZ);
    Params :=  VarArrayOf([0.0,0.0,0.0]);
  {$ENDIF}

  // UCalc
  {$IFDEF Ucalc2}
   ucLicense('Insert your license number hire!!!');
   ucDefineFunction('mean()', Longword( @ucalcAverage ));
  {$ENDIF}

   // DelphiWebScript II
  {$IFDEF DelphiWebScript2}
    Script := TDelphiWebScriptII.Create(Self);
  {$ENDIF}
  
  // CioinaEval
  New(P1);
  New(P2);
  New(P3);
  SetLength(ar,3);
  ar[0].StrExpr:='x';
  ar[0].Value:=P1;
  ar[0].Protect:=true;
  
  ar[1].StrExpr:='y';
  ar[1].Value:=P2;
  ar[1].Protect:=true;
  
  ar[2].StrExpr:='z';
  ar[2].Value:=P3;
  ar[2].Protect:=true;

  SetLength(UserFunc,2);
  UserFunc[0].FuncName:='rand';
  UserFunc[0].FuncAddress:=CioinaRandom;
  UserFunc[0].VarCount:=-1;
  
  UserFunc[1].FuncName:='MySum';
  UserFunc[1].FuncAddress:=CioinaMySum;
  UserFunc[1].VarCount:=CioinaEval.MaxFuncParam;
  
  Ev:=TCioinaEval.Create(UserFunc);
  Ev.OnVerifySyntaxSemanticsError:=ParseErrorMesssage;
  Ev.OnDoMathExpressionError:=ExecuteErrorMesssage;
  SetLength(UserFunc,0);

  //StExpr
  Expr:=TStExpression.Create(Self);
  Expr.ClearIdentifiers;
  Expr.AddInternalFunctions;
  Expr.AddVariable('x', @XX);
  Expr.AddVariable('y', @YY);
  Expr.AddVariable('z', @ZZ);
  
  Expr.AddConstant('Pi',Pi);
  Expr.AddConstant('E',Exp(1));
  Expr.AddConstant('Inf',Infinity);
  Expr.AddConstant('Nan',Nan);
  Expr.AddConstant('True',1);
  Expr.AddConstant('False',0);

  Expr.AddFunction0Param('rand',RandomEx);
  Expr.AddFunction2Param('Power',MyPowerEx);
  Expr.AddFunction3Param('MySum',MySumEx);

  // Parser10
  DynaParser := TParser.Create(Self);
  PP:=DynaParser.SetVariable('z',1.0);
  DynaParser.AddFunctionOneParam('MyFun',MyFuncPr);
  DynaParser.AddFunctionTwoParam('MyPower',MyPowerPr);

  // RbwParser
  RbwParser1 := TRbwParser.Create(Self);
  RbwParser1.CreateVariable('x', 0.0);
  RbwParser1.CreateVariable('y', 0.0);
  RbwParser1.CreateVariable('z', 0.0);
  VarX := RbwParser1.Variables[RbwParser1.IndexOfVariable('x')] as TRealVariable;
  VarY := RbwParser1.Variables[RbwParser1.IndexOfVariable('y')] as TRealVariable;
  VarZ := RbwParser1.Variables[RbwParser1.IndexOfVariable('z')] as TRealVariable;
  PiFunction.ResultType := rdtDouble;
  PiFunction.Name := 'HalfPi';
  SetLength(PiFunction.InputDataTypes, 0);
  PiFunction.OptionalArguments := 0;
  PiFunction.CanConvertToConstant := True;
  PiFunction.RFunctionAddr := _HalfPi;
  RbwParser1.Functions.Add(PiFunction);
  SumFunction.ResultType := rdtDouble;
  SumFunction.Name := 'Sum';
  SetLength(SumFunction.InputDataTypes, 3);
  SumFunction.OptionalArguments := 0;
  SumFunction.CanConvertToConstant := False;
  SumFunction.RFunctionAddr := _Sum;
  RbwParser1.Functions.Add(SumFunction);

  // ExpressionParser
  ExprParser1 := TExpressionParser.Create;
  ExprParser1.DefineVariable('x', @X);
  ExprParser1.DefineVariable('y', @Y);
  ExprParser1.DefineVariable('z', @Z);

  // CalcExpess2
  CalcExpress1:= TCalcExpress.Create(Self);
{$IFDEF LINUX}
  VarList:=TMemo.CreateParented(Application.AppWidget);
{$ENDIF}
{$IFDEF MSWINDOWS}
  VarList:=TMemo.CreateParented(Application.Handle);
{$ENDIF}
  VarList.Lines.Add('x');
  VarList.Lines.Add('y');
  VarList.Lines.Add('z');
  CalcExpress1.Variables:=VarList.Lines;

  // DiffExpress
  DiffExpress1:=TDiffExpress.Create(Self);

  // SadMan's ExpressionEvaluator
  ExpressionEvaluator1:= TExpressionEvaluator.Create(Self);
  ExpressionEvaluator1.NamedValues.Add('x',0);
  ExpressionEvaluator1.NamedValues.Add('y',0);
  ExpressionEvaluator1.NamedValues.Add('z',0);

  // PegtopFormula
  Formula:=TPegtopFormula.Create(Self);
  Formula.Parameters.Add('x');
  Formula.Parameters.Add('y');
  Formula.Parameters.Add('z');

  // UnitParsor
//  VarEval:=TExpress.Create;
//  VarEval.VariableList:=LowerCase('xyz');

  // ExpressIt
  ExpressIt1:=TExpressIt.Create(Self);
  ExpressIt1.ObjectLexicon.Add(TExpressionComponent.Create('Form', Self));
  ExpressIt1.FunctionLexicon.Add(TXValue);
  ExpressIt1.FunctionLexicon.Add(TYValue);
  ExpressIt1.FunctionLexicon.Add(TZValue);
  ExpressIt1.FunctionLexicon.Add(TAbs);

  // MathParser
  AFuncParser:=TMathParser.Create;
  AFuncParser.RegisterExtendedOperators;
  AFuncParser.RegisterConversionOperators;
  AFuncParser.AddConstant('x',0);
  AFuncParser.AddConstant('y',0);
  AFuncParser.AddConstant('z',0);

  //  ArtFormula
  FN := TArtFormulaN.Create(Self);
  SetLength(varArr, 3);
  varArr[0]:='x';
  varArr[1]:='y';
  varArr[2]:='z';
  SetLength(vals, 3);

  // JclExprEval
  {$IFDEF TCompEv}
    FEvaluator := TCompiledEvaluator.Create;
    FConstEvaluator:= JclExprEval.TEvaluator.Create;

  with FConstEvaluator do
  begin
    // Variables
    AddVar('x',x);
    AddVar('y',y);
    AddVar('z',z);

    // Constants
    AddConst('Pi', Pi);
    AddConst('E', Exp(1));
    AddConst('Inf', Infinity);
    AddConst('Nan', Nan);
    AddConst('True', 1);
    AddConst('False', 0);

    // Functions
    AddFunc('rand',MyRandom);
    AddFunc('MySum',MySum);
    AddFunc('power',MyPower);
    AddFunc('ArcTan2', jclMath.ArcTan2);
    AddFunc('cos', Cos);
    AddFunc('sin', Sin);
    AddFunc('cot', jclMath.Cot);
    AddFunc('Abs', MyAbs);
    AddFunc('Tan', MyTan);
    AddFunc('Log10',LogBase10);
    AddFunc('Log2', LogBase2);
    AddFunc('log', LogBaseN);
    AddFunc('ln', MyLn);
  end;
 {$ELSE}
   FEvaluator := JclExprEval.TEvaluator.Create;
 {$ENDIF}
 
  with FEvaluator do
  begin
    // Variables
    AddVar('x',x);
    AddVar('y',y);
    AddVar('z',z);

    // Constants
    AddConst('Pi', Pi);
    AddConst('E', Exp(1));
    AddConst('Inf', Infinity);
    AddConst('Nan', Nan);
    AddConst('True', 1);
    AddConst('False', 0);

    // Functions
    AddFunc('rand',MyRandom);
    AddFunc('MySum',MySum);
    AddFunc('power',MyPower);
    AddFunc('ArcTan2', jclMath.ArcTan2);
    AddFunc('cos', Cos);
    AddFunc('sin', Sin);
    AddFunc('cot', jclMath.Cot);
    AddFunc('Abs', MyAbs);
    AddFunc('Tan', MyTan);
    AddFunc('Log10',LogBase10);
    AddFunc('Log2', LogBase2);
    AddFunc('log', LogBaseN);
    AddFunc('ln', MyLn);
  end;

 Caption:='JclExprEval 1.17 vs '+Ev.VersionInfo +' vs TurboPower '+Expr.Version+' vs prExpr 1.04 etc.';
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  // RemObjects Pascal Scripter
 {$IFDEF RemObjectPS}
   Compiler.Free;
   Exec.Free; 
 {$ENDIF}

  // ScripterStudio
 {$IFDEF ScriptStudio}
  //FScripter.Free;
 {$ENDIF}

  // Sparksoft 's Expression Parser 
 {$IFDEF ExprParser3}
   SparkParser1.Free;
 {$ENDIF}

  // Fast Script
 {$IFDEF FastScript} 
   fsScript1.Free;
 {$ENDIF}

  // DelphiWebScript II
 {$IFDEF DelphiWebScript2}
   Script.Free;
 {$ENDIF}

  // CioinaEval
  Dispose(P1);
  Dispose(P2);
  Dispose(P3);
  SetLength(ar,0);
  Ev.Free;
  
  // JclExprEval
  FEvaluator.Free;
 {$IFDEF TCompEv}
  FConstEvaluator.Free;
 {$ENDIF} 

  // StExpr
  Expr.Free;

  // Parser10
  DynaParser.ClearFunctions;
  DynaParser.ClearVariables;
  DynaParser.Free;

  // RbwParser
  RbwParser1.Free;

  // ExpressionParser
  ExprParser1.Free; 

  // CalcExpess2
  VarList.Free;
  CalcExpress1.Free;

  // DiffExpress
  DiffExpress1.Free;

  // SadMan's ExpressionEvaluator
  ExpressionEvaluator1.Free;

  // PegtopFormula
  Formula.Free;
  
  // UnitParsor
//  VarEval.Free;
  
  // ExpressIt
  ExpressIt1.Free;

  // MathParser
  AFuncParser.FreeLastTermTree;
  AFuncParser.Free;

  //  ArtFormula
  FN.Destroy;
  SetLength(varArr, 0);
  SetLength(vals, 0);
 
  // prExpr: do not know how to free
  EG3Expr:= CreateExpression('0', EG2IDFunc);
  EG3Expr:= nil;
end;

procedure TForm1.Evaluate;
var
  S            : string;
  start,finish,
  finishp      : TDateTime;
  h,min,sec,ml : Word;
  i,n          : Integer;
  d,d1         : Extended;
  flag         : Boolean;
  c1,c2        : Cardinal;

begin
  try
   n:=StrToInt(Edit1.Text);
  except  on E:Exception do
   begin
    Memo1.Lines.Add(E.Message);
    Exit;
   end;
  end;

  Memo1.Lines.Add('-----------------------------Loop count: '+IntToStr(n)+'---------------------------');

  // CioinaEval
  if CheckBox1.Checked
  then
  begin
   Ev.SpaceLikeMultiply:=false;
   S:=StringReplace(Memo2.Text,''#$D'','',[rfReplaceAll]);
   S:=StringReplace(Trim(S),''#$A'','',[rfReplaceAll]);
   
   start:=Now;
   Ev.VerifySyntaxSemantics(S, ar, false);
   finishp:=Now-start;

   if Ev.ErrorFlag
   then Memo1.Lines.Add('CioinaEval-> ' + CioinaEvalError)
   else
   begin
     d:=0;
     start:=Now;
     for i:=1 to n do
     begin
      P1^:=1.0/i;
      P2^:=1.0/i;
      P3^:=1.0/i;
      d:=d+Ev.DoMathExpression;
     end;
     finish:=Now-start;
     DecodeTime(finish,h,min,sec,ml);
     c1:=sec*1000+ml+min*60000;
     DecodeTime(finishp,h,min,sec,ml);
     c2:=sec*1000+ml+min*60000;
     if Ev.ErrorFlag
     then Memo1.Lines.Add('CioinaEval-> ' + CioinaEvalError)
     else Memo1.Lines.Add('CioinaEval-> Result= '+ FloatToStr(d)+ '  Timing= '+IntToStr(c1)+ ' msec'+'   Parse= '+ IntToStr(c2)+' msec');
   end;
  end;

  // JclExprEval
  if CheckBox2.Checked
  then
  begin
   {$IFDEF TCompEv}
   try
     flag:=false;
     S := Memo2.Text;
     start:=Now;
     if Length(S)>300
     then flag:=true
     else
     begin
      x:=1.0;
      y:=1.0;
      z:=1.0;
      d1:=FConstEvaluator.Evaluate(S);
     end;
     FEvaluator.Compile(S);
     d:=FEvaluator.Evaluate;
     finishp:=Now-start;

     if not(flag) then
      if(jclMath.IsNan(d1))and(jclMath.IsNan(d))
      then flag:=true
      else
       if not((jclMath.IsNan(d1))or(jclMath.IsNan(d)))
       then
         if(d1=d)
         then flag:=true
         else
          if (d<>0.0) then flag:=true;

     if flag
     then
     begin
      d:=0;
      start:=Now;
      for i:=1 to n do
      begin
       x:=1.0/i;
       y:=1.0/i;
       z:=1.0/i;
       d:=d+FEvaluator.Evaluate;
      end;
      finish:=Now-start;
     end
     else
     begin
      d:=0;
      start:=Now;
      for i:=1 to n do  d:=d+d1;
      finish:=Now-start;
     end;
     DecodeTime(finish,h,min,sec,ml);
     c1:=sec*1000+ml+min*60000;
     DecodeTime(finishp,h,min,sec,ml);
     c2:=sec*1000+ml+min*60000;
     S :='JclExprEval-> Result= '+ FloatToStr(d)+ '  Timing= '+IntToStr(c1)+ ' msec'+'   Parse= '+ IntToStr(c2)+' msec';
   except
     on E: Exception do  S := 'JclExprEval-> '+E.Message;
   end;
   {$ELSE}
   try
     S := Memo2.Text;
     d:=0;
     start:=GetTickCount;
     for i:=1 to n do
     begin
      x:=1.0/i;
      y:=1.0/i;
      z:=1.0/i;
      d:=d+FEvaluator.Evaluate(S);
     end;
     finish:=GetTickCount-start;
     DecodeTime(finish,h,min,sec,ml);
     c1:=sec*1000+ml+min*60000;
     S :='JclExprEval-> Result= '+ FloatToStr(d)+ '  Timing= '+IntToStr(c1)+ ' msec';
   except
     on E: Exception do  S := 'JclExprEval-> '+E.Message;
   end;
   {$ENDIF}
   Memo1.Lines.Add(S);
  end;

  // prExpr
  if CheckBox3.Checked
  then
  begin
   try
    S := Memo2.Text;
    start:=Now;
    EG3Expr:= CreateExpression(S, EG2IDFunc);
    finishp:=Now-start;
    if Assigned(EG3Expr)
    then
    begin
     d:=0;
     start:=Now;
     for i:=1 to n do
     begin
      xxx:=1.0/i;
      yyy:=1.0/i;
      zzz:=1.0/i;
      d:=d+EG3Expr.AsFloat;
     end;
     finish:=Now-start;
     DecodeTime(finish,h,min,sec,ml);
     c1:=sec*1000+ml+min*60000;
     DecodeTime(finishp,h,min,sec,ml);
     c2:=sec*1000+ml+min*60000;
     S :='prExpr-> Result= '+ FloatToStr(d)+ '  Timing= '+IntToStr(c1)+ ' msec'+'   Parse= '+ IntToStr(c2)+' msec';
    end
    else S := 'PrExpr-> Error!!!'
    except
     on E: Exception do  S := 'PrExpr-> '+E.Message;
   end;
   Memo1.Lines.Add(S);
  end;


  // StExpr
  if CheckBox4.Checked
  then
  begin
   try
     S := Memo2.Text;
     start:=Now;
     Expr.Expression := S;
     x:=1.0;
     y:=1.0;
     z:=1.0;
     Expr.AnalyzeExpression;
     finishp:=Now-start;

     d:=0;
     start:=Now;
     for i:=1 to n do
     begin
      xx:=1.0/i;
      yy:=1.0/i;
      zz:=1.0/i;
      d:=d+Expr.AsFloat;
     end;
     finish:=Now-start;
     DecodeTime(finish,h,min,sec,ml);
     c1:=sec*1000+ml+min*60000;
     DecodeTime(finishp,h,min,sec,ml);
     c2:=sec*1000+ml+min*60000;
     S :='StExpr-> Result= '+ FloatToStr(d)+ '  Timing= '+IntToStr(c1)+ ' msec'+'   Parse= '+ IntToStr(c2)+' msec';
    except
     on E: Exception do  S := 'StExpr-> '+E.Message;
   end;
   Memo1.Lines.Add(S);
  end;

  // CalcExpess2
  if CheckBox5.Checked
  then
  begin
   try
    S := Memo2.Text;
    start:=Now;
    CalcExpress1.Formula := S;
    finishp:=Now-start;
    if CalcExpress1.ErrorFlag
    then S :='CalcExpess 2.1-> Error in formula.'
    else
    begin
     d:=0;
     start:=Now;
     for i:=1 to n do
     begin
      args[0]:=1.0/i; // Variable X
      args[1]:=1.0/i; // Variable Y
      args[2]:=1.0/i; // Variable Z
      d:=d+CalcExpress1.Calc(args)
     end;
     finish:=Now-start;
     DecodeTime(finish,h,min,sec,ml);
     c1:=sec*1000+ml+min*60000;
     DecodeTime(finishp,h,min,sec,ml);
     c2:=sec*1000+ml+min*60000;
     S :='CalcExpess 2.1-> Result= '+ FloatToStr(d)+ '  Timing= '+IntToStr(c1)+ ' msec'+'   Parse= '+ IntToStr(c2)+' msec';
    end;
   except
    on E: Exception do  S := 'CalcExpess 2.1-> '+E.Message;
   end;
   Memo1.Lines.Add(S);
  end;

  //  Parser10
  if CheckBox6.Checked
  then
  begin
   try
    S := Memo2.Text;
    start:=Now;
    DynaParser.Expression:=S;
    finishp:=Now-start;
    d:=0;
    start:=Now;
    for i:=1 to n do
    begin
     DynaParser.X:=1.0/i;
     DynaParser.Y:=1.0/i;
     PP^:=1.0/i;
     d:=d+DynaParser.Value;
     if DynaParser.ParserError
     then
     begin
      S:='Parser 10.2 -> Error';
      Break;
     end;
    end;
    if not(DynaParser.ParserError)
    then
    begin
     finish:=Now-start;
     DecodeTime(finish,h,min,sec,ml);
     c1:=sec*1000+ml+min*60000;
     DecodeTime(finishp,h,min,sec,ml);
     c2:=sec*1000+ml+min*60000;
     S :='Parser 10.2-> Result= '+ FloatToStr(d)+ '  Timing= '+IntToStr(c1)+ ' msec'+'   Parse= '+ IntToStr(c2)+' msec';
    end;
   except
    on E: Exception do  S := 'Parser 10.2-> '+E.Message;
   end;
   Memo1.Lines.Add(S);
  end;

  // ExpressionParser
  if CheckBox7.Checked
  then
  begin
   try
    S := Memo2.Text;
    start:=Now;
    ExprParser1.ClearExpressions;
    ExprParser1.AddExpression(S);
    finishp:=Now-start;
    d:=0;
    start:=Now;
    for i:=1 to n do
    begin
     x:=1.0/i;
     y:=1.0/i;
     z:=1.0/i;
     d:=d+ExprParser1.EvaluateCurrent;
    end;
    finish:=Now-start;
    DecodeTime(finish,h,min,sec,ml);
    c1:=sec*1000+ml+min*60000;
    DecodeTime(finishp,h,min,sec,ml);
    c2:=sec*1000+ml+min*60000;
    S :='ExpressionParser 1.2-> Result= '+ FloatToStr(d)+ '  Timing= '+IntToStr(c1)+ ' msec'+'   Parse= '+ IntToStr(c2)+' msec';
   except
    on E: Exception do  S := 'ExpressionParser 1.2-> '+E.Message;
   end;
   Memo1.Lines.Add(S);
  end;

  // SadMan's ExpressionEvaluator
  if CheckBox8.Checked
  then
  begin
   try
    S := Memo2.Text;
    start:=Now;
    ExpressionEvaluator1.Expression:=S;
    ExpressionEvaluator1.NamedValues.Values[0].Value:=1.0;
    ExpressionEvaluator1.NamedValues.Values[1].Value:=1.0;
    ExpressionEvaluator1.NamedValues.Values[2].Value:=1.0;
    ExpressionEvaluator1.Value;
    finishp:=Now-start;
    d:=0;
    start:=Now;
    for i:=1 to n do
    begin
     ExpressionEvaluator1.NamedValues.Values[0].Value:=1.0/i;
     ExpressionEvaluator1.NamedValues.Values[1].Value:=1.0/i;
     ExpressionEvaluator1.NamedValues.Values[2].Value:=1.0/i;
     d:=d+ExpressionEvaluator1.Value;
    end;
    finish:=Now-start;
    DecodeTime(finish,h,min,sec,ml);
    c1:=sec*1000+ml+min*60000;
    DecodeTime(finishp,h,min,sec,ml);
    c2:=sec*1000+ml+min*60000;
    S :='SadMan ExpEval-> Result= '+ FloatToStr(d)+ '  Timing= '+IntToStr(c1)+ ' msec'+'   Parse= '+ IntToStr(c2)+' msec';
   except
    on E: Exception do  S := 'SadMan ExpEval-> '+E.Message;
   end;
   Memo1.Lines.Add(S);
  end;

  // PegtopFormula
  if CheckBox9.Checked
  then
  begin
   try
    S := Memo2.Text;
    start:=Now;
    Formula.Expression:=S;
    Formula.Compile;
    finishp:=Now-start;
    d:=0;
    start:=Now;
    for i:=1 to n do
    begin
     Formula.SetArg(0,1.0/i);
     Formula.SetArg(1,1.0/i);
     Formula.SetArg(2,1.0/i);
     d:=d+Formula.Eval;
    end;
    finish:=Now-start;
    DecodeTime(finish,h,min,sec,ml);
    c1:=sec*1000+ml+min*60000;
    DecodeTime(finishp,h,min,sec,ml);
    c2:=sec*1000+ml+min*60000;
    S :='PegtopFormula-> Result= '+ FloatToStr(d)+ '  Timing= '+IntToStr(c1)+ ' msec'+'   Parse= '+ IntToStr(c2)+' msec';
   except
    on E: Exception do  S := 'PegtopFormula-> '+E.Message;
   end;
   Memo1.Lines.Add(S);
  end;
  
  // RbwParser
  if CheckBox10.Checked
  then
  begin
   try
    S := Memo2.Text;
    start:=Now;
    RbwParser1.Compile(S);
    finishp:=Now-start;
    d:=0;
    start:=Now;
    for i:=1 to n do
    begin
     VarX.Value:=1.0/i;
     VarY.Value:=1.0/i;
     VarZ.Value:=1.0/i;
     RbwParser1.CurrentExpression.Evaluate;
     d:= d + RbwParser1.CurrentExpression.DoubleResult
    end;
    finish:=Now-start;
    DecodeTime(finish,h,min,sec,ml);
    c1:=sec*1000+ml+min*60000;
    DecodeTime(finishp,h,min,sec,ml);
    c2:=sec*1000+ml+min*60000;
    S :='RbwParser-> Result= '+ FloatToStr(d)+ '  Timing= '+IntToStr(c1)+ ' msec'+'   Parse= '+ IntToStr(c2)+' msec';
   except
    on E: Exception do  S := 'RbwParser-> '+E.Message;
   end;
   Memo1.Lines.Add(S);
  end;
    
  // RemObjects Pascal Scripter
  {$IFDEF RemObjectPS}
  if CheckBox11.Checked
  then
  begin
   try
    S:='function test(x, y, z :Double): String; begin  Result := FloatToStr(' + Memo2.Text + '); end;';
    start:=Now;
    if Compiler.Compile(S) then  // Compile the Pascal script into bytecode.
    begin
     Compiler.GetOutput(ByteCodeData); // Save the output of the compiler in the string Data.
     finishp:=Now-start;
     if Exec.LoadData(ByteCodeData) then // Load the data from the Data string.
     begin
      TestFunc := TTestFunction(Exec.GetProcAsMethodN('Test'));
      d:=0;
      start:=Now;
      if @TestFunc <> nil 
      then
       for i:=1 to n do
       begin
        xPS := 1.0/i;
        yPS := 1.0/i;
        zPS := 1.0/i;
        d:= d + StrToFloat(TestFunc(xPS,yPS,zPS));
       end;
      finish:=Now-start;
      DecodeTime(finish,h,min,sec,ml);
      c1:=sec*1000+ml+min*60000;
      DecodeTime(finishp,h,min,sec,ml);
      c2:=sec*1000+ml+min*60000;
      S :='RemObjects-> Result= '+ FloatToStr(d)+ '  Timing= '+IntToStr(c1)+ ' msec'+'   Parse= '+ IntToStr(c2)+' msec';
     end
     else
     begin
      S := 'RemObjects-> Execution Error: ' + Exec.ExceptionString;
     end;
    end
    else
    begin
      S :='';
      for i :=0  to  Compiler.MsgCount-1  do  S := S + Compiler.Msg[i].MessageToString;
      S := 'RemObjects-> Compilation Error: ' + S;
    end;
   except
    on E: Exception do  S := 'RemObjects-> '+E.Message;
   end;
   Memo1.Lines.Add(S);
  end;
  {$ENDIF}

  // ExpressIt
  if CheckBox12.Checked
  then
  begin
   try
    S := Memo2.Text;
    start:=Now;
    vExpression1 := ExpressIt1.ParseToExpression(S);
    finishp:=Now-start;
    if not ExpressIt1.Errors
    then
    begin
      d:=0;
      start:=Now;
      for i:=1 to n do
      begin
        xIt:=1.0/i;
        yIt:=1.0/i;
        zIt:=1.0/i;
        if vExpression1.Execute
        then  d:=d+vExpression1.Resultant
        else
        begin
         S:='ExpressIt-> '+vExpression1.ErrorText;
         Break;
        end;
      end;
      if vExpression1.Execute
      then
      begin
        finish:=Now-start;
        DecodeTime(finish,h,min,sec,ml);
        c1:=sec*1000+ml+min*60000;
        DecodeTime(finishp,h,min,sec,ml);
        c2:=sec*1000+ml+min*60000;
        S :='ExpressIt-> Result= '+ FloatToStr(d)+ '  Timing= '+IntToStr(c1)+ ' msec'+'   Parse= '+ IntToStr(c2)+' msec';
      end;
    end
    else
    begin
    	S:='ExpressIt-> '+ ExpressIt1.ErrorText;
    end;
   except
    on E: Exception do  S := 'ExpressIt-> '+E.Message;
   end;
   Memo1.Lines.Add(S);
   FreeAndNil(vExpression1);
  end;
  
  // PaxScripter
  {$IFDEF PaxScrip}
  if CheckBox13.Checked
  then
  begin
  try
   p:=TPaxScripter.Create(nil);
   lang:=TPaxPascal.Create(nil);
   p.OnShowError:=doOnError;
   try
    S := Memo2.Text;
    p.RegisterLanguage(lang);
    p.AddModule('1',lang.LanguageName);
    p.AddCode('1','function f(x,y,z: Double):Double; begin  result:=' + S + '; end;');
    p.RegisterObject('Form1', form1);
    start:=Now;
    p.run;
    finishp:=Now-start;
    if p.IsError then raise exception.create(p.ErrorDescription);
    d:=0;
    start:=Now;
    for i:=1 to n do
    begin
      //d:=d+p.CallFunction('f',[1.0/i, 1.0/i, 1.0/i]);
      //Try this is your version is greater than 3.0
      d:=d+p.CallFunctionByID(1,[1.0/i, 1.0/i, 1.0/i]);
     
      if p.IsError then raise exception.create(p.ErrorDescription);
    end;
    finish:=Now-start;
    DecodeTime(finish,h,min,sec,ml);
    c1:=sec*1000+ml+min*60000;
    DecodeTime(finishp,h,min,sec,ml);
    c2:=sec*1000+ml+min*60000;
    S :='PaxScripter-> Result= '+ FloatToStr(d)+ '  Timing= '+IntToStr(c1)+ ' msec'+'   Parse= '+ IntToStr(c2)+' msec';
   finally
    p.UnregisterLanguage(lang.LanguageName);
    freeAndNil(lang);
    freeandnil(p);
   end;
  except
   on E: Exception do  S := 'PaxScripter-> '+E.Message;
  end;
    Memo1.Lines.Add(S);
  end;
  {$ENDIF}

  // SripterStudio
  {$IFDEF ScriptStudio}
  if CheckBox14.Checked
  then
  begin
  try
    S := Memo2.Text;
    start:=Now;
    FScripter.SourceCode.Text := 'function f; begin  result:=' + S + '; end;';
    ARoutine := AnsiDequotedstr('f', '"');
    FScripter.Compile;
    finishp:=Now-start;
    d:=0;
    start:=Now;
    for i:=1 to n do
    begin
      StudX := 1.0/i;
      StudY := 1.0/i;
      StudZ := 1.0/i;
      d:=d + FScripter.ExecuteSubRoutine(ARoutine);
    end;
    finish:=Now-start;
    DecodeTime(finish,h,min,sec,ml);
    c1:=sec*1000+ml+min*60000;
    DecodeTime(finishp,h,min,sec,ml);
    c2:=sec*1000+ml+min*60000;
    S :='ScripterStudio-> Result= '+ FloatToStr(d)+ '  Timing= '+IntToStr(c1)+ ' msec'+'   Parse= '+ IntToStr(c2)+' msec';
  except
   on E: Exception do  S := 'ScripterStudio-> '+E.Message;
  end;
    Memo1.Lines.Add(S);
  end;
 {$ENDIF}

  // Symbolic
  if CheckBox15.Checked
  then
  begin
	try
    S := Memo2.Text;
    try 
     VarName:=TStringList.Create;
     VarName.Add('X');
     VarName.Add('Y');
     VarName.Add('Z');
     flag:=true;
     start:=Now;
     Expr1:=Symbolic.TExpression.Create(S);
     try 
      Eval:=Symbolic.TEvaluator.Create(VarName, Expr1);
      finishp:=Now-start;
      try
       d:=0;
       start:=Now;
       for i:=1 to n do
       begin
        Vars[0]:=1.0/i; 
        Vars[1]:=1.0/i; 
        Vars[2]:=1.0/i;
        d:=d + Eval.Evaluate(Vars);
       end;
       finish:=Now-start;
       DecodeTime(finish,h,min,sec,ml);
       c1:=sec*1000+ml+min*60000;
       DecodeTime(finishp,h,min,sec,ml);
       c2:=sec*1000+ml+min*60000;
       S :='Symbolic-> Result= '+ FloatToStr(d)+ '  Timing= '+IntToStr(c1)+ ' msec'+'   Parse= '+ IntToStr(c2)+' msec';
      finally
       freeAndNil(Eval);
       flag:=false;
       // VarName.Free;  {Is freed by TEvaluator.Destroy. Should TEvaluator copy it? Marco van de Voort (marco@freepascal.org)}
      end;
    finally
     freeAndNil(Expr1);
    end;
   finally
    if flag  then freeAndNil(VarName);
   end;
  except
   on E: Exception do  S := 'Symbolic-> '+E.Message;
  end;
    Memo1.Lines.Add(S);
  end;

    // Sparksoft 's Expression Parser 
  {$IFDEF ExprParser3}
  if CheckBox16.Checked
  then
  begin
  try
    S := Memo2.Text;
    start:=Now;
    SparkParser1.Expr:=S;
    SparkParser1.DoCheck;
    finishp:=Now-start;
    d:=0;
    start:=Now;
    for i:=1 to n do
    begin
      SpX.Value:=1.0/i;
      SpY.Value:=1.0/i;
      SpZ.Value:=1.0/i;
      d:=d +SparkParser1.F([]);
    end;
    finish:=Now-start;
    DecodeTime(finish,h,min,sec,ml);
    c1:=sec*1000+ml+min*60000;
    DecodeTime(finishp,h,min,sec,ml);
    c2:=sec*1000+ml+min*60000;
    S :='Sparksoft Parser-> Result= '+ FloatToStr(d)+ '  Timing= '+IntToStr(c1)+ ' msec'+'   Parse= '+ IntToStr(c2)+' msec';
  except
   on E: Exception do  S := 'Sparksoft Parser-> '+E.Message;
  end;
    Memo1.Lines.Add(S);
  end;
  {$ENDIF}
  
  // Fast Script
  {$IFDEF FastScript}
  if CheckBox17.Checked
  then
  begin
  try
   S := Memo2.Text;
   start:=Now;
   fsScript1.Clear;
   fsScript1.Lines.Text := 'function f(x, y, z:double):double; begin  result:=' + S + '; end;BEGIN END.';
   if fsScript1.Compile 
   then
   begin
    finishp:=Now-start; 
    d:=0;
    start:=Now;
    for i:=1 to n do
    begin
      Params[0]:=1.0/i;
      Params[1]:=1.0/i;
      Params[2]:=1.0/i;
      d:=d + fsScript1.CallFunction('f' ,Params);
    end;
    finish:=Now-start;
    DecodeTime(finish,h,min,sec,ml);
    c1:=sec*1000+ml+min*60000;
    DecodeTime(finishp,h,min,sec,ml);
    c2:=sec*1000+ml+min*60000;
    S :='FastScript-> Result= '+ FloatToStr(d)+ '  Timing= '+IntToStr(c1)+ ' msec'+'   Parse= '+ IntToStr(c2)+' msec';
   end
   else S:=fsScript1.ErrorMsg;
  except
   on E: Exception do  S := 'FastScript-> '+E.Message;
  end;
    Memo1.Lines.Add(S);
  end;
  {$ENDIF}
  
  // DelphiWebScript II
  {$IFDEF DelphiWebScript2}
  if CheckBox18.Checked
  then
  begin
  try
    S := Memo2.Text;
    start:=Now;
    prog := Script.Compile('var x, y, z, res : float; res := ' + S );
    finishp:=Now-start;
    try
     if not prog.Msgs.HasCompilerErrors then
     begin
      d:=0;
      start:=Now;
      prog.BeginProgram;
      for i:=1 to n do
      begin
       prog.Info['x'] := 1.0/i;
       prog.Info['y'] := 1.0/i;
       prog.Info['z'] := 1.0/i;
       prog.RunProgram(0);
       d := d + prog.Info['res'];
      end;
      prog.EndProgram;
      finish:=Now-start;
      DecodeTime(finish,h,min,sec,ml);
      c1:=sec*1000+ml+min*60000;
      DecodeTime(finishp,h,min,sec,ml);
      c2:=sec*1000+ml+min*60000;
      S :='DelphiWebScript-> Result= '+ FloatToStr(d)+ '  Timing= '+IntToStr(c1)+ ' msec'+'   Parse= '+ IntToStr(c2)+' msec';
    end
    else
    begin
     S := 'DelphiWebScript-> '+prog.Msgs.Msgs[0].AsInfo;
    end;   
   except
   on E: Exception do  S := 'DelphiWebScript-> '+E.Message;
   end;
  finally
    prog.Free;
  end;
   Memo1.Lines.Add(S);
  end;
  {$ENDIF}

  // MathParser
  if CheckBox19.Checked
  then
  begin
  try
    S := Memo2.Text;
    start:=Now;
    AFuncTree:=AFuncParser.ParseTerm(S);
    finishp:=Now-start;
    d:=0;
    start:=Now;
    if AFuncParser.ParseError = mpeNone 
    then 
    begin
     for i:=1 to n do
     begin
      AFuncParser.ConstantValues['x']:=1.0/i;
      AFuncParser.ConstantValues['y']:=1.0/i;
      AFuncParser.ConstantValues['z']:=1.0/i;
      d:=d + AFuncParser.CalcTree(AFuncTree);
     end;
     finish:=Now-start;
     DecodeTime(finish,h,min,sec,ml);
     c1:=sec*1000+ml+min*60000;
     DecodeTime(finishp,h,min,sec,ml);
     c2:=sec*1000+ml+min*60000;
     S :='MathParser-> Result= '+ FloatToStr(d)+ '  Timing= '+IntToStr(c1)+ ' msec'+'   Parse= '+ IntToStr(c2)+' msec';
    end
    else 
    begin
     S :='MathParser-> Other Error';
    end; 
    AFuncParser.FreeTermTree(AFuncTree);
  except
   on e: EMathParserException do S := 'MathParser-> ' + e.ErrorDescription;
   on E: Exception do  S := 'MathParser-> '+ E.Message;
  end;
    Memo1.Lines.Add(S);
  end;

  //  ArtFormula
  if CheckBox20.Checked
  then
  begin
   try
    S := Memo2.Text;
    start:=Now;
    FN.Compile(S, 3, @varArr);
    finishp:=Now-start;
    d:=0;
    start:=Now;
    for i:=1 to n do
    begin
     vals[0]:= 1.0/i;
     vals[1]:= 1.0/i;
     vals[2]:= 1.0/i;
     d:= d + FN.Compute(@vals);
    end;
    finish:=Now-start;
    DecodeTime(finish,h,min,sec,ml);
    c1:=sec*1000+ml+min*60000;
    DecodeTime(finishp,h,min,sec,ml);
    c2:=sec*1000+ml+min*60000;
    S :='ArtFormula-> Result= '+ FloatToStr(d)+ '  Timing= '+IntToStr(c1)+ ' msec'+'   Parse= '+ IntToStr(c2)+' msec';
   except
    on E: Exception do  S := 'ArtFormula-> '+E.Message;
   end;
   Memo1.Lines.Add(S);
  end;

 // EquTranslator
 {$IFDEF EquTranslator2}
  if CheckBox21.Checked
  then
  begin
   try
    S := Memo2.Text;
    start:=Now;
    EquTranslatorMathFunc := PChar('F(x, y, z) = ' + S);
    BuildEqu(EquTranslatorMathFunc);
    finishp:=Now-start;
    d:=0;
    start:=Now;
    for i:=1 to n do
    begin
     EquTranslatorArgs[0]:= 1.0/i;
     EquTranslatorArgs[1]:= 1.0/i;
     EquTranslatorArgs[2]:= 1.0/i;
     d:= d + CalcFor(@EquTranslatorArgs);
    end;
    finish:=Now-start;
    DecodeTime(finish,h,min,sec,ml);
    c1:=sec*1000+ml+min*60000;
    DecodeTime(finishp,h,min,sec,ml);
    c2:=sec*1000+ml+min*60000;
    S :='EquTranslator-> Result= '+ FloatToStr(d)+ '  Timing= '+IntToStr(c1)+ ' msec'+'   Parse= '+ IntToStr(c2)+' msec';
   except
    on E: Exception do  S := 'EquTranslator-> '+E.Message;
   end;
   Memo1.Lines.Add(S);
  end;
 {$ENDIF}

 // PaxCompiler
  {$IFDEF PaxComp}
  if CheckBox22.Checked
  then
  begin
  try
    PaxCompiler1:= TPaxCompiler.Create(nil);
    PaxPascalLanguage1:= TPaxPascalLanguage.Create(nil);
    PaxProgram1:= TPaxProgram.Create(nil);
   try
    S := Memo2.Text;
    PaxCompiler1.RegisterLanguage(PaxPascalLanguage1);
    H_Res := PaxCompiler1.RegisterVariable(0, 'R', _typeDOUBLE, @R);
    PaxCompiler1.AddModule('1',PaxPascalLanguage1.LanguageName);
    PaxCompiler1.AddCode('1', 'procedure P(x,y,z: Double);');
    PaxCompiler1.AddCode('1', 'begin');
    PaxCompiler1.AddCode('1', 'R:=' + S );
    PaxCompiler1.AddCode('1', 'end;');
    PaxCompiler1.AddCode('1', 'begin');
    PaxCompiler1.AddCode('1', 'end.');

    start:=Now;

   if PaxCompiler1.Compile(PaxProgram1) then
   begin
    H_Proc := PaxCompiler1.GetHandle(0, 'P', true);
    ProcPointer := PaxProgram1.GetAddress(H_Proc); // get address of script-defind procedure
    finishp:=Now-start;
     d:=0;
     start:=Now;
     for i:=1 to n do
     begin
       PaxProgram1.BeginCall;
       TProcP(ProcPointer)(1.0/i, 1.0/i, 1.0/i); // call it
       PaxProgram1.EndCall;
       d:= d + R;
     end;
     finish:=Now-start;
     DecodeTime(finish,h,min,sec,ml);
     c1:=sec*1000+ml+min*60000;
     DecodeTime(finishp,h,min,sec,ml);
     c2:=sec*1000+ml+min*60000;
     S :='PaxCompiler-> Result= '+ FloatToStr(d)+ '  Timing= '+IntToStr(c1)+ ' msec'+'   Parse= '+ IntToStr(c2)+' msec';
    end
    else
    begin
      S := '';
      for I:=0 to PaxCompiler1.ErrorCount - 1 do S:= S + PaxCompiler1.ErrorMessage[I];
    end;
   finally
    FreeAndNil(PaxCompiler1);
    FreeAndNil(PaxPascalLanguage1);
    FreeAndNil(PaxProgram1);
   end;
  except
   on E: Exception do  S := 'PaxCompiler-> '+E.Message;
  end;
    Memo1.Lines.Add(S);
  end;
  {$ENDIF}   

  // UCalc
  {$IFDEF Ucalc2}
  if CheckBox23.Checked
  then
  begin
  VariableX := ucDefineVariable('x');
  VariableY := ucDefineVariable('y');
  VariableZ := ucDefineVariable('z');
  try
   try
    S := Memo2.Text;
    start:=Now;
    UserEq := ucParse(S);
    finishp:=Now-start;
    flag :=false;
    d:=0;
    start:=Now;
    for i:=1 to n do
    begin
      ucSetVariableValue(VariableX, 1.0/i);
      ucSetVariableValue(VariableY, 1.0/i);
      ucSetVariableValue(VariableZ, 1.0/i);
      d:= d + ucEvaluate(UserEq);
      if ucError <> 0
      then
      begin
       S := 'UCalc-> '+ucErrorMessage;
       flag := true;
       Break;
      end;
    end;
    if not(flag)
    then
    begin
     finish:=Now-start;
     DecodeTime(finish,h,min,sec,ml);
     c1:=sec*1000+ml+min*60000;
     DecodeTime(finishp,h,min,sec,ml);
     c2:=sec*1000+ml+min*60000;
     S :='UCalc-> Result= '+ FloatToStr(d)+ '  Timing= '+IntToStr(c1)+ ' msec'+'   Parse= '+ IntToStr(c2)+' msec';
    end;
   except
    on E: Exception do  S := 'UCalc-> '+E.Message;
   end;
  finally
   ucReleaseExpr;
  end;
  Memo1.Lines.Add(S);
  end;
  {$ENDIF}

  // UnitParsor
  // This code was comented because UnitParsor is very unusable
//  if CheckBox10.Checked
//  then
//  begin
//   try
//    S := Memo2.Text;
//    start:=Now;
//    VarEval.Expression:=LowerCase(S);
//    finishp:=Now-start;
//    d:=0;
//    start:=Now;
//    for i:=1 to n do
//    begin
//     d:=d+VarEval.TheFunction(1.0/i,1.0/i,1.0/i);
//    end;
//    finish:=Now-start;
//    DecodeTime(finish,h,min,sec,ml);
//    c1:=sec*1000+ml+min*60000;
//    DecodeTime(finishp,h,min,sec,ml);
//    c2:=sec*1000+ml+min*60000;
//    S :='UnitParsor-> Result= '+ FloatToStr(d)+ '  Timing= '+IntToStr(c1)+ ' msec'+'   Parse= '+ IntToStr(c2)+' msec';
//   except
//    on E: Exception do  S := 'UnitParsor-> '+E.Message;
//   end;
//   Memo1.Lines.Add(S);
//  end;


 // FParser does not work in Delphi!!!
//      BEGIN
//        InitSymbolTable;
//
//        DefineParameter('y',30.0);
//        DefineParameter('x',0);
//
//        IF TranslateToPostfix('x := Sin(y*Pi/180);') THEN
//          IF ExecutePostFix THEN
//            WriteLn('Result = ',ViewParameter('x'));
//      END;


  Memo1.Lines.Add('-----------------------------End test--------------------------------------------');
end;

//------------------------------------------------------------------------------
procedure TForm1.EnterButtonClick(Sender: TObject);
begin
  Evaluate;
end;

//------------------------------------------------------------------------------
procedure TForm1.cbDrawClick(Sender: TObject);
begin
 PaintBox1.Invalidate;
end;

//------------------------------------------------------------------------------
procedure TForm1.RadioGroup1Click(Sender: TObject);
begin
 PaintBox1.Invalidate
end;

//------------------------------------------------------------------------------

function Compiled(var epX,epY:Double):Double;
begin
  result := 9*255*255*abs((sin(5*epX)+cos(epY*3)+Tan(epX*2))/1.5);
end;

// The initial author of this test procedure is Richard Winston rbwinston@mindspring.com
procedure TForm1.Button1Click(Sender: TObject);
var
  PosX, PosY,
  ThisValue,i   : Integer;
  epX, epY, 
  d,d1          : Double;
  StartCount, 
  StopCount, 
  Speed         : TLargeInteger;
  Sum64         : Int64;
  flag          : Boolean;
  MathExprStr   : string;
begin
  Edit2.Text := '';
  Edit3.Text := '';
  Edit5.Text := '';
  Edit6.Text := '';
  Sum64 := 0;
  QueryPerformanceFrequency(Speed);
  case RadioGroup1.ItemIndex of
    0: // compiled
      begin
        With PaintBox1 do
        begin
          for PosX := 0 to Width -1 do
          begin
            epX := PosX/Width*3;
            for PosY := 0 to Height -1 do
            begin
              epY := PosY/Height*3;
              QueryPerformanceCounter(StartCount);
              ThisValue := Trunc(Compiled(epX,epY));
              QueryPerformanceCounter(StopCount);
              Sum64 := Sum64 + StopCount - StartCount;
              if cbDraw.Checked then
              begin
                Canvas.Pen.Color := ThisValue;
                Canvas.Brush.Color := ThisValue;
                Canvas.Rectangle(PosX-1, PosY-1, PosX+1, PosY+1);
              end;
            end;
          end;
        end;
       CompiledTime := Sum64/Speed;        
      end;
      
    1: // CioinaEval
      begin
       Ev.SpaceLikeMultiply:=true;
       Ev.VerifySyntaxSemantics(Edit4.Text, ar, false);
       if Ev.ErrorFlag
       then Edit6.Text:='CioinaEval-> ' + CioinaEvalError
       else
       begin
        With PaintBox1 do
        begin
          for PosX := 0 to Width -1 do
          begin
            P1^ := PosX/Width*3;
            for PosY := 0 to Height -1 do
            begin
              P2^ := PosY/Height*3;
              QueryPerformanceCounter(StartCount);
              d:=Ev.DoMathExpression;
              QueryPerformanceCounter(StopCount);
              Sum64 := Sum64 + StopCount - StartCount;
              if not Ev.ErrorFlag
              then
              begin
               ThisValue := Trunc(d);
               if cbDraw.Checked then
               begin
                 Canvas.Pen.Color := ThisValue;
                 Canvas.Brush.Color := ThisValue;
                 Canvas.Rectangle(PosX-1, PosY-1, PosX+1, PosY+1);
               end;
              end
              else
              begin
                Edit6.Text:='CioinaEval-> ' + CioinaEvalError;
              end;
            end;
          end;
        end;
     end;
  end;

  {$IFDEF TCompEv}
  2:  // JclExprEval
   try
     flag:=false;
     if Length(Edit4.Text)>300
     then flag:=true
     else
     begin
      x:=1.0;
      y:=1.0;
      z:=1.0;
      d1:=FConstEvaluator.Evaluate(Edit4.Text);
     end;
     FEvaluator.Compile(Edit4.Text);
     d:=FEvaluator.Evaluate;
     if not(flag) then
      if(jclMath.IsNan(d1))and(jclMath.IsNan(d))
      then flag:=true
      else
       if not((jclMath.IsNan(d1))or(jclMath.IsNan(d)))
       then
         if(d1=d)
         then flag:=true
         else
          if (d<>0.0) then flag:=true;

     if flag
     then
     begin
        With PaintBox1 do
        begin
          for PosX := 0 to Width -1 do
          begin
            x := PosX/Width*3;
            for PosY := 0 to Height -1 do
            begin
              y := PosY/Height*3;
              QueryPerformanceCounter(StartCount);
              ThisValue := Trunc(FEvaluator.Evaluate);
              QueryPerformanceCounter(StopCount);
              Sum64 := Sum64 + StopCount - StartCount;
              if cbDraw.Checked then
              begin
                Canvas.Pen.Color := ThisValue;
                Canvas.Brush.Color := ThisValue;
                Canvas.Rectangle(PosX-1, PosY-1, PosX+1, PosY+1);
              end;
            end;
          end;
        end;
     end
   except
     on E: Exception do  Edit6.Text:='JclExprEval-> '+E.Message;
   end;
  {$ENDIF}

  3: // prExpr
   try
    EG3Expr:= CreateExpression(Edit4.Text, EG2IDFunc);
    if Assigned(EG3Expr)
    then
    begin
        With PaintBox1 do
        begin
          for PosX := 0 to Width -1 do
          begin
            xxx := PosX/Width*3;
            for PosY := 0 to Height -1 do
            begin
              yyy := PosY/Height*3;
              QueryPerformanceCounter(StartCount);
              ThisValue := Trunc(EG3Expr.AsFloat);
              QueryPerformanceCounter(StopCount);
              Sum64 := Sum64 + StopCount - StartCount;
              if cbDraw.Checked then
              begin
                Canvas.Pen.Color := ThisValue;
                Canvas.Brush.Color := ThisValue;
                Canvas.Rectangle(PosX-1, PosY-1, PosX+1, PosY+1);
              end;
            end;
          end;
        end;
    end
    else Edit6.Text:='PrExpr-> Error!!!'
    except
     on E: Exception do  Edit6.Text:='PrExpr-> '+E.Message;
   end;

   4: // StExpr
   try
     Expr.Expression := Edit4.Text;
       With PaintBox1 do
        begin
          for PosX := 0 to Width -1 do
          begin
            xx := PosX/Width*3;
            for PosY := 0 to Height -1 do
            begin
              yy := PosY/Height*3;
              QueryPerformanceCounter(StartCount);
              ThisValue := Trunc(Expr.AsFloat);
              QueryPerformanceCounter(StopCount);
              Sum64 := Sum64 + StopCount - StartCount;
              if cbDraw.Checked then
              begin
                Canvas.Pen.Color := ThisValue;
                Canvas.Brush.Color := ThisValue;
                Canvas.Rectangle(PosX-1, PosY-1, PosX+1, PosY+1);
              end;
            end;
          end;
        end;
    except
     on E: Exception do  Edit6.Text:='StExpr-> '+E.Message;
   end;

   5: // CalcExpess2
   try
    CalcExpress1.Formula := Edit4.Text;
    if CalcExpress1.ErrorFlag
    then Edit6.Text:='CalcExpess 2.1-> Error in formula.'
    else
        With PaintBox1 do
        begin
          for PosX := 0 to Width -1 do
          begin
            args[0] := PosX/Width*3;
            for PosY := 0 to Height -1 do
            begin
              args[1] := PosY/Height*3;
              QueryPerformanceCounter(StartCount);
              ThisValue := Trunc(CalcExpress1.Calc(args));
              QueryPerformanceCounter(StopCount);
              Sum64 := Sum64 + StopCount - StartCount;
              if cbDraw.Checked then
              begin
                Canvas.Pen.Color := ThisValue;
                Canvas.Brush.Color := ThisValue;
                Canvas.Rectangle(PosX-1, PosY-1, PosX+1, PosY+1);
              end;
            end;
          end;
        end;
   except
    on E: Exception do  Edit6.Text:='CalcExpess 2.1-> '+E.Message;
   end;

   6: //  Parser10
   try
     DynaParser.Expression := Edit4.Text;
        With PaintBox1 do
        begin
          for PosX := 0 to Width -1 do
          begin
            DynaParser.X := PosX/Width*3;
            for PosY := 0 to Height -1 do
            begin
              DynaParser.Y := PosY/Height*3;
              QueryPerformanceCounter(StartCount);
              d:=DynaParser.Value;
              QueryPerformanceCounter(StopCount);
              Sum64 := Sum64 + StopCount - StartCount;
              if DynaParser.ParserError
              then
              begin
                Edit6.Text:='Parser 10.2 -> Error';
                Break;
              end
              else
              begin
               ThisValue := Trunc(d);
               if cbDraw.Checked then
               begin
                Canvas.Pen.Color := ThisValue;
                Canvas.Brush.Color := ThisValue;
                Canvas.Rectangle(PosX-1, PosY-1, PosX+1, PosY+1);
               end;
              end;
            end;
          end;
        end;
   except
    on E: Exception do  Edit6.Text:='Parser 10.2-> '+E.Message;
   end;

   7:  // ExpressionParser
   try
    ExprParser1.ClearExpressions;
    ExprParser1.AddExpression(Edit4.Text);
       With PaintBox1 do
        begin
          for PosX := 0 to Width -1 do
          begin
            x := PosX/Width*3;
            for PosY := 0 to Height -1 do
            begin
              y := PosY/Height*3;
              QueryPerformanceCounter(StartCount);
              ThisValue := Trunc(ExprParser1.EvaluateCurrent);
              QueryPerformanceCounter(StopCount);
              Sum64 := Sum64 + StopCount - StartCount;
              if cbDraw.Checked then
              begin
                Canvas.Pen.Color := ThisValue;
                Canvas.Brush.Color := ThisValue;
                Canvas.Rectangle(PosX-1, PosY-1, PosX+1, PosY+1);
              end;
            end;
          end;
        end;
   except
    on E: Exception do  Edit6.Text:='ExpressionParser 1.2-> '+E.Message;
   end;

   8:  // SadMan's ExpressionEvaluator
   try
    ExpressionEvaluator1.Expression := Edit4.Text;
       With PaintBox1 do
        begin
          for PosX := 0 to Width -1 do
          begin
            ExpressionEvaluator1.NamedValues.Values[0].Value := PosX/Width*3;
            for PosY := 0 to Height -1 do
            begin
              ExpressionEvaluator1.NamedValues.Values[1].Value := PosY/Height*3;
              QueryPerformanceCounter(StartCount);
              ThisValue := Trunc(ExpressionEvaluator1.Value);
              QueryPerformanceCounter(StopCount);
              Sum64 := Sum64 + StopCount - StartCount;
              if cbDraw.Checked then
              begin
                Canvas.Pen.Color := ThisValue;
                Canvas.Brush.Color := ThisValue;
                Canvas.Rectangle(PosX-1, PosY-1, PosX+1, PosY+1);
              end;
            end;
          end;
        end;
   except
    on E: Exception do  Edit6.Text:='SadMan ExpEval-> '+E.Message;
   end;

   9:  // PegtopFormula
   try
    Formula.Expression := Edit4.Text;
    Formula.Compile;
       With PaintBox1 do
        begin
          for PosX := 0 to Width -1 do
          begin
            Formula.SetArg(0, PosX/Width*3);
            for PosY := 0 to Height -1 do
            begin
              Formula.SetArg(1, PosY/Height*3);
              QueryPerformanceCounter(StartCount);
              ThisValue := Trunc(Formula.Eval);
              QueryPerformanceCounter(StopCount);
              Sum64 := Sum64 + StopCount - StartCount;
              if cbDraw.Checked then
              begin
                Canvas.Pen.Color := ThisValue;
                Canvas.Brush.Color := ThisValue;
                Canvas.Rectangle(PosX-1, PosY-1, PosX+1, PosY+1);
              end;
            end;
          end;
        end;
   except
    on E: Exception do  Edit6.Text:='PegtopFormula-> '+E.Message;
   end;

   10: // RbwParser
   try
    MathExprStr := Edit4.Text;
    RbwParser1.Compile(MathExprStr);
       With PaintBox1 do
        begin
          for PosX := 0 to Width -1 do
          begin
            VarX.Value := PosX/Width*3;
            for PosY := 0 to Height -1 do
            begin
              VarY.Value := PosY/Height*3;
              QueryPerformanceCounter(StartCount);
              RbwParser1.CurrentExpression.Evaluate;
              ThisValue := Trunc(RbwParser1.CurrentExpression.DoubleResult);
              QueryPerformanceCounter(StopCount);
              Sum64 := Sum64 + StopCount - StartCount;
              if cbDraw.Checked then
              begin
                Canvas.Pen.Color := ThisValue;
                Canvas.Brush.Color := ThisValue;
                Canvas.Rectangle(PosX-1, PosY-1, PosX+1, PosY+1);
              end;
            end;
          end;
        end;
   except
    on E: Exception do  Edit6.Text:='RbwParser-> '+E.Message;
   end;

  {$IFDEF RemObjectPS}
   11: // RemObjects Pascal Scripter
   try
    MathExprStr:='function test(x, y, z :Double): String; begin  Result := FloatToStr(' + Edit4.Text + '); end;';
    if Compiler.Compile(MathExprStr) then  // Compile the Pascal script into bytecode.
    begin
     Compiler.GetOutput(ByteCodeData); // Save the output of the compiler in the string Data.
     if Exec.LoadData(ByteCodeData) then // Load the data from the Data string.
     begin
      TestFunc := TTestFunction(Exec.GetProcAsMethodN('Test'));
      if @TestFunc <> nil
      then
      With PaintBox1 do
        begin
          for PosX := 0 to Width -1 do
          begin
            xPS := PosX/Width*3;
            for PosY := 0 to Height -1 do
            begin
              yPS := PosY/Height*3;
              zPS := 0;
              QueryPerformanceCounter(StartCount);
              ThisValue := Trunc(StrToFloat(TestFunc(xPS,yPS,zPS)));
              QueryPerformanceCounter(StopCount);
              Sum64 := Sum64 + StopCount - StartCount;
              if cbDraw.Checked then
              begin
                Canvas.Pen.Color := ThisValue;
                Canvas.Brush.Color := ThisValue;
                Canvas.Rectangle(PosX-1, PosY-1, PosX+1, PosY+1);
              end;
            end;
          end;
        end;
     end
     else
     begin
      Edit6.Text:='RemObjects-> Execution Error: ' + Exec.ExceptionString;
     end;
    end
    else
    begin
      MathExprStr :='';
      for i :=0  to  Compiler.MsgCount-1  do  MathExprStr := MathExprStr + Compiler.Msg[i].MessageToString;
      Edit6.Text:='RemObjects-> Compilation Error: ' + MathExprStr;
    end;
   except
    on E: Exception do  Edit6.Text:='RemObjects-> '+E.Message;
   end;
  {$ENDIF}

  12:  // ExpressIt
  begin
   try
    vExpression1 := ExpressIt1.ParseToExpression(Edit4.Text);
    if not ExpressIt1.Errors
    then
    begin
       With PaintBox1 do
        begin
          for PosX := 0 to Width -1 do
          begin
            xIt := PosX/Width*3;
            for PosY := 0 to Height -1 do
            begin
              yIt := PosY/Height*3;
              QueryPerformanceCounter(StartCount);
              if vExpression1.Execute
              then
              begin
               ThisValue := Trunc(vExpression1.Resultant);
               QueryPerformanceCounter(StopCount);
               Sum64 := Sum64 + StopCount - StartCount;
               if cbDraw.Checked then
               begin
                 Canvas.Pen.Color := ThisValue;
                 Canvas.Brush.Color := ThisValue;
                 Canvas.Rectangle(PosX-1, PosY-1, PosX+1, PosY+1);
               end;
              end
              else
              begin
               Edit6.Text:='ExpressIt-> '+vExpression1.ErrorText;
               Break;
              end;
            end;
          end;
        end;
    end
    else
    begin
      Edit6.Text:='ExpressIt-> '+ ExpressIt1.ErrorText;
    end;
   except
    on E: Exception do  Edit6.Text:='ExpressIt-> '+E.Message;
   end;
   FreeAndNil(vExpression1);
  end;

  {$IFDEF PaxScrip}
  13:  // PaxScripter
  try
   p:=tPaxScripter.Create(nil);
   lang:=tpaxPascal.create(nil);
   p.OnShowError:=doOnError;
   try
    p.RegisterLanguage(lang);
    p.AddModule('1',lang.LanguageName);
    p.AddCode('1','function f(x,y,z: Double):Double; begin  result:=' + Edit4.Text + '; end;');
    p.RegisterObject('Form1', form1);
    p.run;
    if p.IsError then raise exception.create(p.ErrorDescription);
       With PaintBox1 do
        begin
          for PosX := 0 to Width -1 do
          begin
            for PosY := 0 to Height -1 do
            begin
              QueryPerformanceCounter(StartCount);
              d:=p.CallFunction('f',[PosX/Width*3, PosY/Height*3, 0.0]);
              if p.IsError then raise exception.create(p.ErrorDescription);
              ThisValue := Trunc(d);
              QueryPerformanceCounter(StopCount);
              Sum64 := Sum64 + StopCount - StartCount;
              if cbDraw.Checked then
              begin
                Canvas.Pen.Color := ThisValue;
                Canvas.Brush.Color := ThisValue;
                Canvas.Rectangle(PosX-1, PosY-1, PosX+1, PosY+1);
              end;
            end;
          end;
        end;
   finally
    p.UnregisterLanguage(lang.LanguageName);
    freeAndNil(lang);
    freeandnil(p);
   end;
  except
   on E: Exception do  Edit6.Text:='PaxScripter-> '+E.Message;
  end;
  {$ENDIF}

  {$IFDEF ScriptStudio}
  14:  // SripterStudio
  try
    FScripter.SourceCode.Text := 'function f; begin  result:=' + Edit4.Text + '; end;';
    ARoutine := AnsiDequotedstr('f', '"');
    FScripter.Compile;
       With PaintBox1 do
        begin
          for PosX := 0 to Width -1 do
          begin
            StudX := PosX/Width*3;
            for PosY := 0 to Height -1 do
            begin
              StudY := PosY/Height*3;
              QueryPerformanceCounter(StartCount);
              ThisValue := Trunc(FScripter.ExecuteSubRoutine(ARoutine));
              QueryPerformanceCounter(StopCount);
              Sum64 := Sum64 + StopCount - StartCount;
              if cbDraw.Checked then
              begin
                Canvas.Pen.Color := ThisValue;
                Canvas.Brush.Color := ThisValue;
                Canvas.Rectangle(PosX-1, PosY-1, PosX+1, PosY+1);
              end;
            end;
          end;
        end;
  except
   on E: Exception do  Edit6.Text:='ScripterStudio-> '+E.Message;
  end;
 {$ENDIF}

   15:  // Symbolic
   try
    try
     VarName:=TStringList.Create;
     VarName.Add('X');
     VarName.Add('Y');
     VarName.Add('Z');
     flag:=true;
     Expr1:=Symbolic.TExpression.Create(Edit4.Text);
     try
      Eval:=Symbolic.TEvaluator.Create(VarName, Expr1);
      try
       With PaintBox1 do
        begin
          for PosX := 0 to Width -1 do
          begin
            Vars[0] := PosX/Width*3;
            for PosY := 0 to Height -1 do
            begin
              Vars[1] := PosY/Height*3;
              QueryPerformanceCounter(StartCount);
              ThisValue := Trunc(Eval.Evaluate(Vars));
              QueryPerformanceCounter(StopCount);
              Sum64 := Sum64 + StopCount - StartCount;
              if cbDraw.Checked then
              begin
                Canvas.Pen.Color := ThisValue;
                Canvas.Brush.Color := ThisValue;
                Canvas.Rectangle(PosX-1, PosY-1, PosX+1, PosY+1);
              end;
            end;
          end;
        end;
      finally
       freeAndNil(Eval);
       flag:=false;
       // VarName.Free;  {Is freed by TEvaluator.Destroy. Should TEvaluator copy it? Marco van de Voort (marco@freepascal.org)}
      end;
    finally
     freeAndNil(Expr1);
    end;
   finally
    if flag  then freeAndNil(VarName);
   end;
  except
   on E: Exception do  Edit6.Text:='Symbolic-> '+E.Message;
  end;


  {$IFDEF ExprParser3}
  16: // Sparksoft 's Expression Parser
  try
    SparkParser1.Expr := Edit4.Text;
    SparkParser1.DoCheck;
       With PaintBox1 do
        begin
          for PosX := 0 to Width -1 do
          begin
            SpX.Value := PosX/Width*3;
            for PosY := 0 to Height -1 do
            begin
              SpY.Value := PosY/Height*3;
              QueryPerformanceCounter(StartCount);
              ThisValue := Trunc(SparkParser1.F([]));
              QueryPerformanceCounter(StopCount);
              Sum64 := Sum64 + StopCount - StartCount;
              if cbDraw.Checked then
              begin
                Canvas.Pen.Color := ThisValue;
                Canvas.Brush.Color := ThisValue;
                Canvas.Rectangle(PosX-1, PosY-1, PosX+1, PosY+1);
              end;
            end;
          end;
        end;
  except
   on E: Exception do  Edit6.Text:='Sparksoft Parser-> '+E.Message;
  end;
  {$ENDIF}

  {$IFDEF FastScript}
  17: // Fast Script
  try
   fsScript1.Clear;
   fsScript1.Lines.Text := 'function f(x, y, z:double):double; begin  result:=' + Edit4.Text + '; end;BEGIN END.';
   if fsScript1.Compile
   then
   begin
       With PaintBox1 do
        begin
          for PosX := 0 to Width -1 do
          begin
            Params[0] := PosX/Width*3;
            for PosY := 0 to Height -1 do
            begin
              Params[1] := PosY/Height*3;
              QueryPerformanceCounter(StartCount);
              ThisValue := Trunc(fsScript1.CallFunction('f' ,Params));
              QueryPerformanceCounter(StopCount);
              Sum64 := Sum64 + StopCount - StartCount;
              if cbDraw.Checked then
              begin
                Canvas.Pen.Color := ThisValue;
                Canvas.Brush.Color := ThisValue;
                Canvas.Rectangle(PosX-1, PosY-1, PosX+1, PosY+1);
              end;
            end;
          end;
        end;
   end
   else Edit6.Text:=fsScript1.ErrorMsg;
  except
   on E: Exception do  Edit6.Text:='FastScript-> '+E.Message;
  end;
  {$ENDIF}

  {$IFDEF DelphiWebScript2}
  18: // DelphiWebScript II
  try
    prog := Script.Compile('var x, y, z, res : float; res := ' + Edit4.Text);
    try
     if not prog.Msgs.HasCompilerErrors then
     begin
      prog.BeginProgram;
       With PaintBox1 do
        begin
          for PosX := 0 to Width -1 do
          begin
            prog.Info['x'] := PosX/Width*3;
            for PosY := 0 to Height -1 do
            begin
              prog.Info['y'] := PosY/Height*3;
              QueryPerformanceCounter(StartCount);
              prog.RunProgram(0);
              ThisValue := Trunc(prog.Info['res']);
              QueryPerformanceCounter(StopCount);
              Sum64 := Sum64 + StopCount - StartCount;
              if cbDraw.Checked then
              begin
                Canvas.Pen.Color := ThisValue;
                Canvas.Brush.Color := ThisValue;
                Canvas.Rectangle(PosX-1, PosY-1, PosX+1, PosY+1);
              end;
            end;
          end;
        end;
      prog.EndProgram;
    end
    else
    begin
     Edit6.Text:='DelphiWebScript-> '+prog.Msgs.Msgs[0].AsInfo;
    end;
   except
   on E: Exception do  Edit6.Text:='DelphiWebScript-> '+E.Message;
   end;
  finally
    prog.Free;
  end;
  {$ENDIF}

  19:  // MathParser
  try
    AFuncTree:=AFuncParser.ParseTerm(Edit4.Text);
    if AFuncParser.ParseError = mpeNone
    then
    begin
       With PaintBox1 do
        begin
          for PosX := 0 to Width -1 do
          begin
            AFuncParser.ConstantValues['x'] := PosX/Width*3;
            for PosY := 0 to Height -1 do
            begin
              AFuncParser.ConstantValues['y'] := PosY/Height*3;
              QueryPerformanceCounter(StartCount);
              ThisValue := Trunc(AFuncParser.CalcTree(AFuncTree));
              QueryPerformanceCounter(StopCount);
              Sum64 := Sum64 + StopCount - StartCount;
              if cbDraw.Checked then
              begin
                Canvas.Pen.Color := ThisValue;
                Canvas.Brush.Color := ThisValue;
                Canvas.Rectangle(PosX-1, PosY-1, PosX+1, PosY+1);
              end;
            end;
          end;
        end;
    end
    else
    begin
     Edit6.Text:='MathParser-> Other Error';
    end;
    AFuncParser.FreeTermTree(AFuncTree);
  except
   on e: EMathParserException do Edit6.Text:='MathParser-> ' + e.ErrorDescription;
   on E: Exception do  Edit6.Text:='MathParser-> '+ E.Message;
  end;

   20: // ArtFormula
   try
     FN.Compile(Edit4.Text, 3, @varArr);
       With PaintBox1 do
        begin
          for PosX := 0 to Width -1 do
          begin
            vals[0]:= PosX/Width*3;
            for PosY := 0 to Height -1 do
            begin
              vals[1]:= PosY/Height*3;
              QueryPerformanceCounter(StartCount);
              ThisValue := Trunc(FN.Compute(@vals));
              QueryPerformanceCounter(StopCount);
              Sum64 := Sum64 + StopCount - StartCount;
              if cbDraw.Checked then
              begin
                Canvas.Pen.Color := ThisValue;
                Canvas.Brush.Color := ThisValue;
                Canvas.Rectangle(PosX-1, PosY-1, PosX+1, PosY+1);
              end;
            end;
          end;
        end;
    except
     on E: Exception do  Edit6.Text:='ArtFormula-> '+E.Message;
   end;

  {$IFDEF Ucalc2}
  21: // UCalc
  try
  try
    VariableX := ucDefineVariable('x');
    VariableY := ucDefineVariable('y');
    VariableZ := ucDefineVariable('z');
    UserEq := ucParse(Edit4.Text);

     if ucError = 0 then begin
       With PaintBox1 do
        begin
          for PosX := 0 to Width -1 do
          begin
            ucSetVariableValue(VariableX, PosX/Width*3);
            for PosY := 0 to Height -1 do
            begin
              ucSetVariableValue(VariableY, PosY/Height*3);
              QueryPerformanceCounter(StartCount);
              ThisValue := Trunc(ucEvaluate(UserEq));
              QueryPerformanceCounter(StopCount);
              Sum64 := Sum64 + StopCount - StartCount;
              if cbDraw.Checked then
              begin
                Canvas.Pen.Color := ThisValue;
                Canvas.Brush.Color := ThisValue;
                Canvas.Rectangle(PosX-1, PosY-1, PosX+1, PosY+1);
              end;
            end;
          end;
        end;
     end
     else  Edit6.Text:='UCalc -> ' + ucErrorMessage;

  except
   on E: Exception do  Edit6.Text:='UCalc -> '+E.Message;
  end;
  finally
   ucReleaseExpr;
  end;
  {$ENDIF}

  {$IFDEF EquTranslator2}
  22: // EquTranslator
  try
    EquTranslatorMathFunc := PChar('F(x, y, z) = ' + Edit4.Text);
    BuildEqu(EquTranslatorMathFunc);
       With PaintBox1 do
        begin
          for PosX := 0 to Width -1 do
          begin
            EquTranslatorArgs[0]:= PosX/Width*3;
            for PosY := 0 to Height -1 do
            begin
              EquTranslatorArgs[1]:= PosY/Height*3;
              QueryPerformanceCounter(StartCount);
              ThisValue := Trunc(CalcFor(@EquTranslatorArgs));
              QueryPerformanceCounter(StopCount);
              Sum64 := Sum64 + StopCount - StartCount;
              if cbDraw.Checked then
              begin
                Canvas.Pen.Color := ThisValue;
                Canvas.Brush.Color := ThisValue;
                Canvas.Rectangle(PosX-1, PosY-1, PosX+1, PosY+1);
              end;
            end;
          end;
        end;
  except
   on E: Exception do  Edit6.Text:='EquTranslator -> '+E.Message;
  end;
  {$ENDIF}

  end;


 if RadioGroup1.itemIndex = 0
 then
 begin
   Edit2.Text := FloatToStr(CompiledTime);
   Edit5.Text := IntToStr(Width*Height);
 end
 else
 begin
  if CompiledTime <> 0 then
  begin
    Edit2.Text := FloatToStr(Sum64/Speed);
    Edit3.Text := Format('%.4g',[(Sum64/Speed-CompiledTime)/CompiledTime*100])+'%';
    Edit5.Text := IntToStr(Width*Height);
  end
  else
  begin
    ShowMessage('Please Execute compiled first');
  end;
 end;
end;

//------------------------------------------------------------------------------
procedure TForm1.Button2Click(Sender: TObject);
var s : string;
begin
 s:=StringReplace(Memo3.Text,''#$D'','',[rfReplaceAll]);
 s:=StringReplace(Trim(s),''#$A'','',[rfReplaceAll]);

 // CioinaEval
 Ev.SpaceLikeMultiply:=true;
 Ev.VerifySyntaxSemanticsAndDerivation(s, DiffVar.Text);
 if Ev.ErrorFlag
 then Memo4.Text:=CioinaEvalError
 else Memo4.Text:=Ev.DerivativeExpressionString;

 // DiffExpress
 try
  DiffExpress1.Formula := LowerCase(s);
  Memo5.Text:=DiffExpress1.diff(DiffVar.Text);
 except
   on E:exception do Memo5.Text:=E.Message;
 end;
 
end;

end.
