program ExprEvalExample;
uses
  Forms,
  ExprEvalExampleMain in 'ExprEvalExampleMain.pas' {Form1},
  JclExprEval in '..\Jcl\JclExprEval.pas',
  JclStrHashMap in '..\Jcl\JclStrHashMap.pas',
  JclMath in '..\Jcl\JclMath.pas',
  JclBase in '..\Jcl\JclBase.pas',
  JclResources in '..\Jcl\JclResources.pas',
  JclSysUtils in '..\Jcl\JclSysUtils.pas',
  JclConsole in '..\Jcl\JclConsole.pas',
  JclFileUtils in '..\Jcl\JclFileUtils.pas',
  JclShell in '..\Jcl\JclShell.pas',
  JclWin32 in '..\Jcl\JclWin32.pas',
  JclStrings in '..\Jcl\JclStrings.pas',
  JclWideStrings in '..\Jcl\JclWideStrings.pas',
  JclLogic in '..\Jcl\JclLogic.pas',
  JclSysInfo in '..\Jcl\JclSysInfo.pas',
  Snmp in '..\Jcl\Snmp.pas',
  JclRegistry in '..\Jcl\JclRegistry.pas',
  Jcl8087 in '..\Jcl\Jcl8087.pas',
  JclIniFiles in '..\Jcl\JclIniFiles.pas',
  JclDateTime in '..\Jcl\JclDateTime.pas',
  JclSecurity in '..\Jcl\JclSecurity.pas',
  StExpr in '..\SysTools\StExpr.pas',
  StBase in '..\SysTools\StBase.pas',
  StConst in '..\SysTools\StConst.pas',
  StMath in '..\SysTools\StMath.pas',
  StDate in '..\SysTools\StDate.pas',
  prExpr in '..\PrExpr\prExpr.pas',
  Parser10 in '..\Parser10\Parser10.pas',
  P10Build in '..\Parser10\P10Build.pas',
  CalcExpress in '..\CalcExpess\CalcExpress.pas',
  ParseClass in '..\ExpressionParser\ParseClass.pas',
  OObjects in '..\ExpressionParser\OObjects.pas',
  ParseExpr in '..\ExpressionParser\ParseExpr.pas',
  SsExpEval in '..\ExpEval\SsExpEval.pas',
  PegtopFormulas in '..\PegtopMath\PegtopFormulas.pas',
  PegtopCompilers in '..\PegtopMath\PegtopCompilers.pas',
  PegtopAssemblers in '..\PegtopMath\PegtopAssemblers.pas',
  RbwParser in '..\RbwParser\RbwParser.pas',
  symbolic in '..\Symbolic\symbolic.pas',
  MathParser in '..\MathParser\MathParser.pas',
  XProcs in '..\ExpressIt\XProcs.pas',
  ComplexExpressIt in '..\ExpressIt\ComplexExpressIt.pas',
  ComplexSupport in '..\ExpressIt\ComplexSupport.pas',
  DateTimeSupport in '..\ExpressIt\DateTimeSupport.pas',
  Expression in '..\ExpressIt\Expression.pas',
  ExpressionConstants in '..\ExpressIt\ExpressionConstants.pas',
  ExpressionDatasetSupport in '..\ExpressIt\ExpressionDatasetSupport.pas',
  Expressioneer in '..\ExpressIt\Expressioneer.pas',
  ExpressionFuncsComplex in '..\ExpressIt\ExpressionFuncsComplex.pas',
  ExpressionFuncsDateTime in '..\ExpressIt\ExpressionFuncsDateTime.pas',
  ExpressionFuncsDateTimeExtended in '..\ExpressIt\ExpressionFuncsDateTimeExtended.pas',
  ExpressionFuncsDateTimeSpan in '..\ExpressIt\ExpressionFuncsDateTimeSpan.pas',
  ExpressionFuncsDialogs in '..\ExpressIt\ExpressionFuncsDialogs.pas',
  ExpressionFuncsPathFile in '..\ExpressIt\ExpressionFuncsPathFile.pas',
  ExpressionFuncsPathFileExtended in '..\ExpressIt\ExpressionFuncsPathFileExtended.pas',
  ExpressionFuncsReals in '..\ExpressIt\ExpressionFuncsReals.pas',
  ExpressionFuncsRealsExtended in '..\ExpressIt\ExpressionFuncsRealsExtended.pas',
  ExpressionFuncsStandard in '..\ExpressIt\ExpressionFuncsStandard.pas',
  ExpressionFuncsStrings in '..\ExpressIt\ExpressionFuncsStrings.pas',
  ExpressionFuncsStringsExtended in '..\ExpressIt\ExpressionFuncsStringsExtended.pas',
  ExpressionFuncsSystem in '..\ExpressIt\ExpressionFuncsSystem.pas',
  ExpressionLexicon in '..\ExpressIt\ExpressionLexicon.pas',
  ExpressionObjects in '..\ExpressIt\ExpressionObjects.pas',
  ExpressionObjectsDataset in '..\ExpressIt\ExpressionObjectsDataset.pas',
  ExpressionOpersComplex in '..\ExpressIt\ExpressionOpersComplex.pas',
  ExpressionOpersStandard in '..\ExpressIt\ExpressionOpersStandard.pas',
  ExpressionOpersStrings in '..\ExpressIt\ExpressionOpersStrings.pas',
  ExpressionParser in '..\ExpressIt\ExpressionParser.pas',
  ExpressionStack in '..\ExpressIt\ExpressionStack.pas',
  ExpressionSupport in '..\ExpressIt\ExpressionSupport.pas',
  ExpressionTokens in '..\ExpressIt\ExpressionTokens.pas',
  ExpressIt in '..\ExpressIt\ExpressIt.pas',
  FileInfoSupport in '..\ExpressIt\FileInfoSupport.pas',
  FileSupport in '..\ExpressIt\FileSupport.pas',
  ListSupport in '..\ExpressIt\ListSupport.pas',
  MatchingSupport in '..\ExpressIt\MatchingSupport.pas',
  MENUBAR in '..\ExpressIt\MENUBAR.PAS',
  MiscConstants in '..\ExpressIt\MiscConstants.pas',
  MiscSupport in '..\ExpressIt\MiscSupport.pas',
  ParserSupport in '..\ExpressIt\ParserSupport.pas',
  PropertySupport in '..\ExpressIt\PropertySupport.pas',
  ResultSupport in '..\ExpressIt\ResultSupport.pas',
  StackSupport in '..\ExpressIt\StackSupport.pas',
  StringSupport in '..\ExpressIt\StringSupport.pas',
  SymbolSupport in '..\ExpressIt\SymbolSupport.pas',
  TokenSupport in '..\ExpressIt\TokenSupport.pas',
  ValueSupport in '..\ExpressIt\ValueSupport.pas',
  VariableSupport in '..\ExpressIt\VariableSupport.pas',
  VersionInfoSupport in '..\ExpressIt\VersionInfoSupport.pas',
  DiffExpress in '..\DiffExpress\DiffExpress.pas',
  formula in '..\ArtFormula\formula.pas',
  formulaf in '..\ArtFormula\formulaf.pas',
  formulan in '..\ArtFormula\formulan.pas',
  formulanf in '..\ArtFormula\formulanf.pas',
  {$IFDEF EquTranslator2}EquTranslator in '..\EquTranslator\EquTranslator.pas',{$ENDIF}
  {$IFDEF Ucalc2}UCALC in '..\UCalc\UCALC.PAS',{$ENDIF}
  CioinaEval ;

  {$R *.res}

begin
  Application.Initialize;
  Application.CreateForm(TForm1, Form1);
  Application.Run;
end.
